/*
 * GProFTPD - A GTK+ frontend for the ProFTPD standalone server.
 * Copyright (C) 2001, 2002, 2003 Magnus-swe <magnus-swe@telia.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 *
 */


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>

GtkWidget *userlist_treeview;
GtkWidget *useradd_directory_entry;
GtkWidget *useradd_incoming_directory_entry;

int turns=0;
int update=1;
char in_speed_1_buffer[8192]="";
char out_speed_1_buffer[8192]="";
char info_buffer[8192]="";
int randomize_length=8;  /* The length of the randomized password */



int
usage_update(GtkWidget *widget, gpointer user_data)
{
    /* Timed update for ftpwho and on/offline status */
    FILE *ftpwho;
    FILE *status_file;
    GtkWidget *usage_textview;
    GtkWidget *status_entry;
    GtkTextBuffer *usage_textbuffer;
    char *status_buffer;
    int result=0;
    gchar *utf8_text=NULL;
    char usage_buffer[BUFSIZ]=""; 
    char get_buffer[BUFSIZ]="";
    char string[]="proftpd:";
    usage_textview = lookup_widget (GTK_WIDGET (widget), "usage_textview");
    status_entry = lookup_widget (GTK_WIDGET (widget), "status_entry");
    
    /* FTP who update */
    if ( (ftpwho = popen("ftpwho -v", "r")) == NULL)
    {
	return( 0 );
    }
    fflush(ftpwho);
    while (fgets(usage_buffer, BUFSIZ, ftpwho)!=NULL)
    {
        strcat(get_buffer, usage_buffer);
    }
    pclose(ftpwho);
    utf8_text = g_locale_to_utf8(get_buffer, strlen(get_buffer), NULL, NULL, NULL);
    usage_textbuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(usage_textview));
    gtk_text_buffer_set_text(usage_textbuffer, utf8_text, strlen(utf8_text));
    if(utf8_text !=NULL)
    g_free(utf8_text);

    /* On - offline checker */
    if( update ) /* so it wont leave zombies */
    {
	update=0;
        if ( (status_file = popen("ps -aux |grep \"proftpd: (accept\" |awk '{print $11}'", "r")) == NULL)
        {
    	    printf("popen failed trying ps");   
            exit(1);
        }
	fflush(status_file);
        status_buffer=(char *)malloc(1024);
        bzero(status_buffer, sizeof(char) * 1024);
        while (fgets(status_buffer, 1024, status_file)!=NULL)
        {
        }
        result=strcmp(string, status_buffer);
        free(status_buffer);
        pclose(status_file);
        if (result <= 0 )
        {
	    gtk_entry_set_text(GTK_ENTRY (status_entry), "  In an ON - LINE state");
        }
        else
           {
		gtk_entry_set_text(GTK_ENTRY (status_entry), "  In an OFF - LINE state");
           }
           update=1;
    }
    return ( TRUE );
}


int
speed_update(GtkWidget *widget, gpointer user_data)
{
    FILE *speed_file;
    GtkWidget *incoming_entry;
    GtkWidget *outgoing_entry;
    int int_speed_1, int_speed_2, int_speed;
    incoming_entry = lookup_widget (GTK_WIDGET (widget), "incoming_entry");
    outgoing_entry = lookup_widget (GTK_WIDGET (widget), "outgoing_entry");
    turns++;
    if ( turns == 1 )
    {                            
	strcpy(in_speed_1_buffer,"");
        strcpy(out_speed_1_buffer,"");
        /* Get incoming speed 1 */
        if ( (speed_file = popen("cat /proc/net/dev |grep eth0 |cut -c8- |awk '{print $1}' |tr -d \"\r\n\"", "r")) == NULL)
        {
            printf("cant open /proc/net/dev");
            return( 0 );      
        }
	fflush(speed_file);
        while (fgets(in_speed_1_buffer, 4096, speed_file)!=NULL)
        {
        }
        pclose(speed_file);
        /* Get outgoing speed 1 */
        if ( (speed_file = popen("cat /proc/net/dev |grep eth0 |cut -c8- |awk '{print $9}' |tr -d \"\r\n\"", "r")) == NULL)
        {
            printf("cant open /proc/net/dev");
            return( 0 );
        }
	fflush(speed_file);
        while (fgets(out_speed_1_buffer, 4096, speed_file)!=NULL)
        {
        }
        pclose(speed_file);
    }
    else
       {
          /* After one second */
          if ( turns == 2 )
          {                    
    	     char total_in_speed_buffer[8192]="";
             char total_out_speed_buffer[8192]="";
             char in_speed_2_buffer[4096]="";
             char out_speed_2_buffer[4096]="";
       
             /* Get incoming speed 2 */
             if ( (speed_file = popen("cat /proc/net/dev |grep eth0 |cut -c8- |awk '{print $1}' |tr -d \"\r\n\"", "r")) == NULL)
             {
        	printf("cant open /proc/net/dev");
                return( 0 );   
             }
	     fflush(speed_file);
             while (fgets(in_speed_2_buffer, 4096, speed_file)!=NULL)
             {
             }
             pclose(speed_file);

             /* Get outgoing speed 2 */
             if ( (speed_file = popen("cat /proc/net/dev |grep eth0 |cut -c8- |awk '{print $9}' |tr -d \"\r\n\"", "r")) == NULL)
             {
                printf("cant open /proc/net/dev");
                return( 0 );      
             }
	     fflush(speed_file);
             while (fgets(out_speed_2_buffer, 4096, speed_file)!=NULL)
             {
             }
             pclose(speed_file);
             /* In speed conversion */
             int_speed_1 = atoi(in_speed_1_buffer);
             int_speed_2 = atoi(in_speed_2_buffer);
             int_speed = int_speed_2 - int_speed_1;
             sprintf(total_in_speed_buffer, "%d", int_speed);
             gtk_entry_set_text(GTK_ENTRY (incoming_entry), total_in_speed_buffer);

             /* Out speed conversion */
             int_speed_1 = atoi(out_speed_1_buffer);
             int_speed_2 = atoi(out_speed_2_buffer);
             int_speed = int_speed_2 - int_speed_1;
             sprintf(total_out_speed_buffer, "%d", int_speed);
             gtk_entry_set_text(GTK_ENTRY (outgoing_entry), total_out_speed_buffer);
             turns = 0;
          }
       }
       return( TRUE );
}


void
list_global  (GtkWidget       *widget,
              gpointer         user_data)
{
    FILE *fp;
    GtkWidget *info_window;
    GtkWidget *global_server_name;
    GtkWidget *global_server_admin_email;
    GtkWidget *global_server_port;
    GtkWidget *global_max_connect;
    GtkWidget *global_idle_timeout;
    GtkWidget *global_resume_uploads;
    GtkWidget *global_resume_downloads;
    GtkWidget *global_download_bandwidth;
    GtkWidget *global_upload_bandwidth;
    GtkWidget *global_show_server_identity;
    GtkWidget *global_show_server_identity_on_off;
    GtkWidget *global_reverse_lookups;
    GtkWidget *global_default_transfer_mode;
    GtkWidget *global_ident_lookups;
    GtkWidget *global_allow_fxp;
    GtkWidget *global_server_user;
    GtkWidget *global_server_group;
    GtkWidget *global_time_standard;
    GtkWidget *global_max_login_attempts;
    GtkWidget *global_timeout_login;
    GtkWidget *global_delete_aborted_stores;
    char *new_buffer, *old_buffer;
    const gchar *length_buffer;
    long size_buffer;
    int global_int=0;
    int begin = 0;
    int end = 0;
    int x=0;
    int length=0;
    global_server_name = lookup_widget (GTK_WIDGET (widget), "global_server_name");
    global_server_admin_email = lookup_widget (GTK_WIDGET (widget), "global_server_admin_email");
    global_server_port = lookup_widget (GTK_WIDGET (widget), "global_server_port");
    global_max_connect = lookup_widget (GTK_WIDGET (widget), "global_max_connect");
    global_idle_timeout = lookup_widget (GTK_WIDGET (widget), "global_idle_timeout");
    global_resume_uploads = lookup_widget (GTK_WIDGET (widget), "global_resume_uploads");
    global_resume_downloads = lookup_widget (GTK_WIDGET (widget), "global_resume_downloads");
    global_download_bandwidth = lookup_widget (GTK_WIDGET (widget), "global_download_bandwidth");
    global_upload_bandwidth = lookup_widget (GTK_WIDGET (widget), "global_upload_bandwidth");
    global_show_server_identity = lookup_widget (GTK_WIDGET (widget), "global_show_server_identity");
    global_show_server_identity_on_off = lookup_widget (GTK_WIDGET (widget), "global_show_server_identity_on_off");
    global_reverse_lookups = lookup_widget (GTK_WIDGET (widget), "global_reverse_lookups");
    global_default_transfer_mode = lookup_widget (GTK_WIDGET (widget), "global_default_transfer_mode");
    global_ident_lookups = lookup_widget (GTK_WIDGET (widget), "global_ident_lookups");
    global_allow_fxp = lookup_widget (GTK_WIDGET (widget), "global_allow_fxp");
    global_server_user = lookup_widget (GTK_WIDGET (widget), "global_server_user");
    global_server_group = lookup_widget (GTK_WIDGET (widget), "global_server_group");
    global_time_standard = lookup_widget (GTK_WIDGET (widget), "global_time_standard");
    global_max_login_attempts = lookup_widget (GTK_WIDGET (widget), "global_max_login_attempts");
    global_timeout_login = lookup_widget (GTK_WIDGET (widget), "global_timeout_login");
    global_delete_aborted_stores = lookup_widget (GTK_WIDGET (widget), "global_delete_aborted_stores");
    if ( (fp = fopen("/etc/proftpd.conf", "r")) == NULL)
    {
	strcpy(info_buffer, "List entire: Cant open /etc/proftpd.conf\n");
        info_window = create_info_window ();
        gtk_widget_show (info_window);
        return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    old_buffer=(char *)malloc(size_buffer);
    bzero(old_buffer, sizeof(char) * size_buffer);   
    new_buffer=(char *)malloc(size_buffer);               
    bzero(new_buffer, sizeof(char) * size_buffer);           
    while(fgets((char*)old_buffer, size_buffer, fp)!=NULL)
    {                                 
	if( strstr(old_buffer, "<") )
	break;           
 
   	if( strstr(old_buffer, "ServerName") )
	{   
	    sprintf(new_buffer, old_buffer);
	    gtk_entry_set_text(GTK_ENTRY (global_server_name), new_buffer);
	    gtk_editable_delete_text(GTK_EDITABLE(global_server_name), 0, 12);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_server_name));  // bad
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_server_name), length -2, length);
	}
   	if( strstr(old_buffer, "ServerAdmin") )
	{   
	    sprintf(new_buffer, old_buffer);
	    gtk_entry_set_text(GTK_ENTRY (global_server_admin_email), new_buffer);
	    gtk_editable_delete_text(GTK_EDITABLE(global_server_admin_email), 0, 12);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_server_admin_email));  // bad
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_server_admin_email), length -1, length);
	}
	if( strstr(old_buffer, "ServerIdent") )
	{
	    sprintf(new_buffer, old_buffer);
	    if( strstr(new_buffer, "on") )
	    {
        	gtk_entry_set_text (GTK_ENTRY (global_show_server_identity), new_buffer);    
		gtk_entry_set_text (GTK_ENTRY (global_show_server_identity_on_off), "on");    
		gtk_editable_delete_text (GTK_EDITABLE (global_show_server_identity), 0, 16);
        	length_buffer = gtk_entry_get_text(GTK_ENTRY(global_show_server_identity));
		length = strlen(length_buffer);
        	gtk_editable_delete_text(GTK_EDITABLE(global_show_server_identity), length -2, length);
	    }
	    else
	      {
        	 gtk_entry_set_text (GTK_ENTRY (global_show_server_identity), new_buffer);
		 gtk_entry_set_text (GTK_ENTRY (global_show_server_identity_on_off), "off");    
		 gtk_editable_delete_text (GTK_EDITABLE (global_show_server_identity), 0, 17);
        	 length_buffer = gtk_entry_get_text(GTK_ENTRY(global_show_server_identity));
		 length = strlen(length_buffer);
        	 gtk_editable_delete_text(GTK_EDITABLE(global_show_server_identity), length -2, length);
	      }
	}
	/* Dont match usepassiveports */
  	if( strstr(old_buffer, "Port ") )
	{
            for (x = 0; x < strlen(old_buffer); x++) 
            {
		if (begin == 0 && (old_buffer[x] >= '0' && old_buffer[x] <= '9')) 
                {
            	    begin = x;
                    continue;
                }
                end = x;
            }
            snprintf(new_buffer, end-begin+1, "%s", old_buffer+begin);
            global_int = atoi(new_buffer);
            gtk_spin_button_set_value(GTK_SPIN_BUTTON(global_server_port), global_int);
            begin=0;
            end=0;
	}
	if( strstr(old_buffer, "MaxInstances") )
	{
            for (x = 0; x < strlen(old_buffer); x++) 
            {
        	if (begin == 0 && (old_buffer[x] >= '0' && old_buffer[x] <= '9')) 
                {
                    begin = x;
                    continue;
                }
                end = x;
            }
            snprintf(new_buffer, end-begin+1, "%s", old_buffer+begin);
            global_int = atoi(new_buffer);
            gtk_spin_button_set_value(GTK_SPIN_BUTTON(global_max_connect), global_int);
	    begin=0;
	    end=0;
	}
	if( strstr(old_buffer, "TimeoutNoTransfer") )
	{
    	    for (x = 0; x < strlen(old_buffer); x++) 
            {
    		if (begin == 0 && (old_buffer[x] >= '0' && old_buffer[x] <= '9')) 
                {
                    begin = x;
                    continue;
                }
                end = x;
            }
            snprintf(new_buffer, end-begin+1, "%s", old_buffer+begin);
            global_int = atoi(new_buffer);
            gtk_spin_button_set_value(GTK_SPIN_BUTTON(global_idle_timeout), global_int);
	    begin=0;
	    end=0;
	}
	if( strstr(old_buffer, "AllowStoreRestart") )
	{
	    sprintf(new_buffer, old_buffer);
            gtk_entry_set_text (GTK_ENTRY (global_resume_uploads), new_buffer);
	    gtk_editable_delete_text (GTK_EDITABLE (global_resume_uploads), 0, 18);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_resume_uploads));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_resume_uploads), length -1, length);
	}
	if( strstr(old_buffer, "AllowRetrieveRestart") )
	{
	    sprintf(new_buffer, old_buffer);
            gtk_entry_set_text (GTK_ENTRY (global_resume_downloads), new_buffer);
	    gtk_editable_delete_text (GTK_EDITABLE (global_resume_downloads), 0, 21);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_resume_downloads));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_resume_downloads), length -1, length);
	}
	if( strstr(old_buffer, "TransferRate RETR") )
	{
            for (x = 0; x < strlen(old_buffer); x++) 
            {
                if (begin == 0 && (old_buffer[x] >= '0' && old_buffer[x] <= '9')) 
                {
                    begin = x;
                    continue;
                }
                end = x;
            }
            snprintf(new_buffer, end-begin+1, "%s", old_buffer+begin);
            global_int = atoi(new_buffer);
            gtk_spin_button_set_value(GTK_SPIN_BUTTON(global_download_bandwidth), global_int);
	    begin=0;
	    end=0;
	}
	if( strstr(old_buffer, "TransferRate STOR") )
	{
            for (x = 0; x < strlen(old_buffer); x++) 
            {
                if (begin == 0 && (old_buffer[x] >= '0' && old_buffer[x] <= '9'))
                {
            	    begin = x;
                    continue;
                }
                end = x;
            }
            snprintf(new_buffer, end-begin+1, "%s", old_buffer+begin);
            global_int = atoi(new_buffer);
            gtk_spin_button_set_value(GTK_SPIN_BUTTON(global_upload_bandwidth), global_int);
	    begin=0;
	    end=0;
	}
        if( strstr(old_buffer, "UseReverseDNS") )
	{
	    sprintf(new_buffer, old_buffer); 
            gtk_entry_set_text (GTK_ENTRY (global_reverse_lookups), new_buffer);    
	    gtk_editable_delete_text (GTK_EDITABLE (global_reverse_lookups), 0, 14);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_reverse_lookups));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_reverse_lookups), length -1, length);
	}
	if( strstr(old_buffer, "IdentLookups") )
	{
	    sprintf(new_buffer, old_buffer);
    	    gtk_entry_set_text (GTK_ENTRY (global_ident_lookups), new_buffer);
	    gtk_editable_delete_text (GTK_EDITABLE (global_ident_lookups), 0, 13);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_ident_lookups));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_ident_lookups), length -1, length);
	}
	if( strstr(old_buffer, "DefaultTransferMode") )
	{
	    sprintf(new_buffer, old_buffer); 
            gtk_entry_set_text (GTK_ENTRY (global_default_transfer_mode), new_buffer);
	    gtk_editable_delete_text (GTK_EDITABLE (global_default_transfer_mode), 0, 20);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_default_transfer_mode));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_default_transfer_mode), length -1, length);
	}
	if( strstr(old_buffer, "User") )
	{
	    sprintf(new_buffer, old_buffer); 
            gtk_entry_set_text (GTK_ENTRY (global_server_user), new_buffer);    
	    gtk_editable_delete_text (GTK_EDITABLE (global_server_user), 0, 5);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_server_user));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_server_user), length -1, length);
	}
	if( strstr(old_buffer, "Group") )
	{
	    sprintf(new_buffer, old_buffer); 
            gtk_entry_set_text (GTK_ENTRY (global_server_group), new_buffer);
	    gtk_editable_delete_text (GTK_EDITABLE (global_server_group), 0, 6);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_server_group));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_server_group), length -1, length);
	}
	if( strstr(old_buffer, "AllowForeignAddress") )
	{
	    sprintf(new_buffer, old_buffer);
            gtk_entry_set_text (GTK_ENTRY (global_allow_fxp), new_buffer);
	    gtk_editable_delete_text (GTK_EDITABLE (global_allow_fxp), 0, 20);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_allow_fxp));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_allow_fxp), length -1, length);
	}
	if( strstr(old_buffer, "TimesGMT") )
	{
	    sprintf(new_buffer, old_buffer);
            gtk_entry_set_text (GTK_ENTRY (global_time_standard), new_buffer);
	    gtk_editable_delete_text (GTK_EDITABLE (global_time_standard), 0, 9);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_time_standard));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_time_standard), length -1, length);
	}
	if( strstr(old_buffer, "MaxLoginAttempts") )
	{
            for (x = 0; x < strlen(old_buffer); x++) 
            {
                if (begin == 0 && (old_buffer[x] >= '0' && old_buffer[x] <= '9')) 
                {
                    begin = x;
                    continue;
                }
                end = x;
            }
            snprintf(new_buffer, end-begin+1, "%s", old_buffer+begin);
            global_int = atoi(new_buffer);
            gtk_spin_button_set_value(GTK_SPIN_BUTTON(global_max_login_attempts), global_int);
	    begin=0;
	    end=0;
	}
	if( strstr(old_buffer, "TimeoutLogin") )
	{
            for (x = 0; x < strlen(old_buffer); x++) 
            {
                if (begin == 0 && (old_buffer[x] >= '0' && old_buffer[x] <= '9')) 
                {
            	    begin = x;
                    continue;
                }
                end = x;
            }
            snprintf(new_buffer, end-begin+1, "%s", old_buffer+begin);
            global_int = atoi(new_buffer);
            gtk_spin_button_set_value(GTK_SPIN_BUTTON(global_timeout_login), global_int);
	    begin=0;
	    end=0;
	}
	if( strstr(old_buffer, "DeleteAbortedStores") )
	{
	    sprintf(new_buffer, old_buffer); 
            gtk_entry_set_text (GTK_ENTRY (global_delete_aborted_stores), new_buffer);    
	    gtk_editable_delete_text (GTK_EDITABLE (global_delete_aborted_stores), 0, 20);
            length_buffer = gtk_entry_get_text(GTK_ENTRY(global_delete_aborted_stores));
	    length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(global_delete_aborted_stores), length -1, length);
	}
    }
    fclose(fp);
    free(old_buffer);
    free(new_buffer);
}


void
list_entire  (GtkWidget       *widget,
              gpointer         user_data)
{
    /* Entire configuration text */
    FILE *fp;
    GtkWidget *info_window;
    GtkTextBuffer *entire_text_buffer;
    GtkWidget *entire_textview;
    gchar *utf8=NULL;            
    long size_buffer;
    char *buffer, *get_buffer;
    entire_textview = lookup_widget (GTK_WIDGET (widget), "entire_textview");
    
    if( (fp = fopen("/etc/proftpd.conf", "r")) == NULL )
    {
	strcpy(info_buffer, "List entire: Cant open /etc/proftpd.conf\n");
        info_window = create_info_window ();
        gtk_widget_show (info_window);
        return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    buffer=(char *)malloc(size_buffer);
    bzero(buffer, size_buffer);
    get_buffer=(char *)malloc(size_buffer+1024);
    bzero(get_buffer, size_buffer+1024);
    entire_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(entire_textview));
    while (fgets(buffer, size_buffer, fp)!=NULL)
    {
	strcat(get_buffer, buffer);
    }
    utf8 = g_locale_to_utf8(get_buffer, strlen(get_buffer), NULL, NULL, NULL);
    gtk_text_buffer_set_text(entire_text_buffer, utf8, strlen(utf8));
    fclose(fp);
    if(utf8 !=NULL)
    g_free(utf8);
    free(buffer);
    free(get_buffer);
}


void
list_users  (GtkWidget       *widget,
             gpointer         user_data)
{
    FILE *fp;
    GtkWidget *info_window;
    GtkListStore *model;
    GtkCellRenderer *cell;
    GtkTreeIter iter;
    GtkTreePath *path;
    char *old_buffer, *new_buffer;
    long size_buffer;
    gboolean edit=0;
    int found=0;
    gchar *utf8=NULL;
    GtkTreeViewColumn *user_column, *group_column, *maxclients_column, *require_column, *maximum_column;
    userlist_treeview = lookup_widget (GTK_WIDGET (widget), "userlist_treeview");
    model = gtk_list_store_new(5, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
    gtk_tree_view_set_model(GTK_TREE_VIEW(userlist_treeview), GTK_TREE_MODEL (model));
    cell = gtk_cell_renderer_text_new();
    user_column = gtk_tree_view_column_new_with_attributes("User", cell, "text", 0, NULL);
    group_column = gtk_tree_view_column_new_with_attributes("Group", cell, "text", 1, NULL);
    maxclients_column = gtk_tree_view_column_new_with_attributes("Home directory", cell, "text", 2, NULL);
    require_column = gtk_tree_view_column_new_with_attributes("Require password", cell, "text", 3, NULL);
    maximum_column = gtk_tree_view_column_new_with_attributes("Maximum simultaneous connections", cell, "text", 4, NULL);
    gtk_list_store_clear(model);

    /* Populate the userlist */
    if ( (fp = fopen("/etc/proftpd.conf", "r")) == NULL)
    {
	printf("List users: Cant open /etc/proftpd.conf\n");
        info_window = create_info_window ();
        gtk_widget_show (info_window);
        return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    old_buffer=(char *)malloc(size_buffer);
    bzero(old_buffer, size_buffer);   
    new_buffer=(char *)malloc(size_buffer+8192);
    bzero(new_buffer, size_buffer+8192);
    while(fgets(old_buffer, size_buffer, fp)!=NULL)
    {
        if( strstr(old_buffer, "<Anonymous ") )
        {
	    sscanf(old_buffer, "%*s %s", new_buffer);
	    new_buffer[strlen(new_buffer)-1]='\0';
    	    utf8 = g_locale_to_utf8(new_buffer, strlen(new_buffer), NULL, NULL, NULL);
    	    gtk_list_store_append(GTK_LIST_STORE(model), &iter);
    	    gtk_list_store_set(GTK_LIST_STORE(model), &iter, 2, utf8, -1);
    	    found=1;
        }
        if( strstr(old_buffer, "User ") && found )  
        {
	    sscanf(old_buffer, "%*s %s", new_buffer);
    	    utf8 = g_locale_to_utf8(new_buffer, strlen(new_buffer), NULL, NULL, NULL);
    	    gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, utf8, -1);
        }
        if( strstr(old_buffer, "Group ") && found )
        {   
	    sscanf(old_buffer, "%*s %s", new_buffer);
    	    utf8 = g_locale_to_utf8(new_buffer, strlen(new_buffer), NULL, NULL, NULL);
    	    gtk_list_store_set(GTK_LIST_STORE(model), &iter, 1, utf8, -1);
    	}
        if( strstr(old_buffer, "AnonRequirePassword ") && found)
        {   
	    sscanf(old_buffer, "%*s %s", new_buffer);
    	    utf8 = g_locale_to_utf8(new_buffer, strlen(new_buffer), NULL, NULL, NULL);
    	    gtk_list_store_set(GTK_LIST_STORE(model), &iter, 3, utf8, -1);
    	}
        if( strstr(old_buffer, "MaxClients ") && found )
        {   
	    sscanf(old_buffer, "%*s %s", new_buffer);
    	    utf8 = g_locale_to_utf8(new_buffer, strlen(new_buffer), NULL, NULL, NULL);
    	    gtk_list_store_set(GTK_LIST_STORE(model), &iter, 4, utf8, -1);
        }
    }
    fclose(fp);
    free(old_buffer);
    free(new_buffer);
    /* Cant set treepath if there arent any users/rows, then itll crash */
    if( ! found )
    {
        if( utf8 !=NULL )
        g_free(utf8);
        return;
    }
    if(utf8 !=NULL)
    g_free(utf8);
    path = gtk_tree_path_new_first();
    gtk_tree_view_set_cursor(GTK_TREE_VIEW(userlist_treeview), path, NULL, edit);
    gtk_tree_path_free(path);
}


void
on_info_window_map  (GtkWidget       *widget,
                     gpointer         user_data)
{
    /* Show a popup information window */
    GtkWidget *info_window;
    GtkWidget *info_textview;
    GtkTextBuffer *info_text_buffer;
    gchar *utf8=NULL;
    info_window = lookup_widget (GTK_WIDGET (widget), "info_window");
    info_textview = lookup_widget (GTK_WIDGET (widget), "info_textview");
    info_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(info_textview));
    utf8 = g_locale_to_utf8(info_buffer, strlen(info_buffer), NULL, NULL, NULL);
    gtk_text_buffer_set_text(info_text_buffer, utf8, strlen(utf8));
    if(utf8 !=NULL)
    g_free(utf8);
}


void
on_gproftpd_window_map                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
    /* This takes care of populating all the widgets 
     * and making sure the environment is sane at startup.
     */
    FILE *fp;
    GtkWidget *gproftpd_window;
    GtkWidget *info_window;
    GtkWidget *files_textview;
    GtkWidget *banned_textview;
    GtkWidget *security_successful_textview;
    GtkWidget *security_refused_textview;
    GtkWidget *usage_textview;
    GtkWidget *disc_treeview;
    GtkWidget *version_entry;
    GtkWidget *status_entry;
    GtkWidget *incoming_entry;
    GtkWidget *outgoing_entry;
    GtkWidget *shell_combo; 
    GdkPixbuf *main_window_pixbuf;
    GtkCellRenderer *pixmap_cell;
    GtkTextBuffer *file_text_buffer;
    GtkTextBuffer *security_text_buffer;
    GtkTreeViewColumn *user_column, *group_column, *maxclients_column, *require_column, *maximum_column;
    GtkTreeViewColumn *mount_column, *free_column, *used_column, *total_column, *percent_column, *device_column;
    char *versionbuffer, *get_buffer, *buffer;
    char *new_buffer, *shell, *file_buffer;
    char *mount, *disc_free, *used, *total, *percent, *device;
    char *default_buffer, *check_buffer, *user_check, *user_add;
    GtkTextBuffer *text_buffer;
    GtkListStore *user_model, *disc_model;
    GtkCellRenderer *cell;
    GtkTreeIter iter;
    long size_buffer;
    GList *items = NULL;
    gchar *utf8=NULL;            
    int found_shell=0;   // Add a /bin/false shell if its not found
    int found_conf=0;
    int found_user=0;
    disc_treeview = lookup_widget (GTK_WIDGET (widget), "disc_treeview");
    files_textview = lookup_widget (GTK_WIDGET (widget), "files_textview");
    
    /* Globals */
    userlist_treeview = lookup_widget (GTK_WIDGET (widget), "userlist_treeview");
    useradd_directory_entry = lookup_widget (GTK_WIDGET (widget), "useradd_directory_entry");
    useradd_incoming_directory_entry = lookup_widget (GTK_WIDGET (widget), "useradd_incoming_directory_entry");

    /* Setup the main window icon */
    pixmap_cell = gtk_cell_renderer_pixbuf_new();
    main_window_pixbuf=gdk_pixbuf_new_from_file("/usr/share/pixmaps/gproftpd.png", NULL);
    g_object_set(pixmap_cell, "pixbuf", main_window_pixbuf, NULL);
    gproftpd_window = lookup_widget (GTK_WIDGET (widget), "gproftpd_window");
    gtk_window_set_icon (GTK_WINDOW (gproftpd_window), main_window_pixbuf);
    gdk_pixbuf_unref (main_window_pixbuf);

    /* Check if /etc/proftpd.conf exists */
    if ( (fp = fopen("/etc/proftpd.conf", "r")) == NULL)
    {
	/* Report nothing */
    }
    else
      {
         found_conf=1;
         fclose(fp);
      }

    /* If /etc/proftpd.conf is not found we add one if the user is root */
    if( ! found_conf )
    {
	if( (fp = fopen("/etc/proftpd.conf", "w+")) == NULL)
	{
    	    strcpy(info_buffer, "Cant open /etc/proftpd.conf for writing\n");
    	    strcat(info_buffer, "the default configuration.\n");
    	    strcat(info_buffer, "Run GProFTPD as root\n");
    	    info_window = create_info_window ();
    	    gtk_widget_show (info_window);
	    return;
	}
	else
          {
	    /* Adding the default configuration .. deprecate the default button ? */
	    default_buffer=(char *)malloc(8192);
	    bzero(default_buffer, 8192);
	    /* The first 3 are not in the global tab .. add inetd functions */
	    strcpy(default_buffer, "ServerType standalone\n");
	    strcat(default_buffer, "DefaultServer on\n");
	    strcat(default_buffer, "Umask 022\n");
	    /* Default configuration list */
	    strcat(default_buffer, "ServerName \"My FTP Server\"\n");
	    strcat(default_buffer, "ServerAdmin Admin@this.domain.topdomain\n");
	    strcat(default_buffer, "ServerIdent on \"Show this instead ?\"\n");
	    strcat(default_buffer, "IdentLookups off\n");
	    strcat(default_buffer, "UseReverseDNS off\n");
	    strcat(default_buffer, "Port 21\n");
	    strcat(default_buffer, "TimesGMT off\n");
	    strcat(default_buffer, "MaxInstances 30\n");
	    strcat(default_buffer, "MaxLoginAttempts 3\n");
	    strcat(default_buffer, "TimeoutLogin 300\n");
	    strcat(default_buffer, "TimeoutNoTransfer 400\n");
	    strcat(default_buffer, "User nobody\n");
	    strcat(default_buffer, "Group nobody\n");
	    strcat(default_buffer, "DefaultTransferMode binary\n");
	    strcat(default_buffer, "AllowForeignAddress on\n");
	    strcat(default_buffer, "AllowRetrieveRestart on\n");
	    strcat(default_buffer, "AllowStoreRestart on\n");
	    strcat(default_buffer, "DeleteAbortedStores off\n");
	    strcat(default_buffer, "TransferRate RETR 20\n");
	    strcat(default_buffer, "TransferRate STOR 30\n");
	    strcat(default_buffer, "TransferRate STOU 30\n");
	    strcat(default_buffer, "TransferRate APPE 30\n");
	    strcat(default_buffer, "#--- End of the global configuration ---#\n");
	    fputs(default_buffer, fp);
	    fclose(fp);
	    free(default_buffer);
    	    strcpy(info_buffer, "Couldnt find /etc/proftpd.conf so the\n");
    	    strcat(info_buffer, "default configuration was added there.\n");
    	    info_window = create_info_window ();
    	    gtk_widget_show (info_window);
        }
    }
    /* Check if the line /bin/false is in /etc/shells, add that line if its not there. */
    if( (fp = fopen("/etc/shells", "r"))==NULL)
    {
        printf("Cant open /etc/shells for reading\n");
    }
    else
      {   
    	 fseek(fp, 0, SEEK_END);
         size_buffer = ftell(fp);
         rewind(fp);
         shell=(char *)malloc(size_buffer);          
         bzero(shell, sizeof(char) * size_buffer);   
         while (fgets(shell, size_buffer, fp)!=NULL) 
         {
            if( strstr(shell, "/bin/false") )
            found_shell=1;
         }
         fclose(fp);
         free(shell);
         if ( ! found_shell )
         {
            if( (fp = fopen("/etc/shells", "a"))==NULL)
            {
                strcpy(info_buffer, "Cant write the line /bin/false to /etc/shells.\n\n");
                strcat(info_buffer, "Run GProFTPD as root\n");
                info_window = create_info_window ();
                gtk_widget_show (info_window);
	        return;
            }
            fputs("\n", fp);
            fputs("/bin/false", fp);
            fclose(fp);
    	 }
      }

    /* Checks if the user nobody exists in /etc/proftpd.conf, if not show a popup */
    if ( (fp = fopen("/etc/passwd","r")) == NULL)
    {
    	printf("Error checking for the nobody user at startup\n");
    	return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    check_buffer=(char *)malloc(size_buffer);
    bzero(check_buffer, size_buffer);
    user_check=(char *)malloc(4096);
    bzero(user_check, sizeof(char) * 4096);
    strcpy(user_check, "nobody:");
    while(fgets(check_buffer, size_buffer, fp)!=NULL)
    {
	if( strstr(check_buffer, user_check) )
	{
	    if( strstr(check_buffer, "nfs") )
	    continue;
	    found_user=1;
	}
    }
    free(user_check);
    free(check_buffer);
    fclose(fp);
    if( ! found_user )
    {
	/* This can be a hazzle for a newb so we make this user and stick it in /etc/ftpusers */
	/* The file is created if it doesnt exist (a) */
	if ( (fp = fopen("/etc/ftpusers", "a")) == NULL)
	{
    	    strcpy(info_buffer, "Cant open /etc/ftpusers for writing\n");
    	    strcat(info_buffer, "Run GProFTPD as root\n");
    	    info_window = create_info_window ();
    	    gtk_widget_show (info_window);
	    return;
	}
	fputs("\nnobody\n", fp);
	fclose(fp);	
	/* Make the system user */
	user_add=(char *)malloc(8192);
	bzero(user_add, 8192);
	strcpy(user_add, "useradd nobody -c master-ftp-user -d /home/ftp -s /bin/false");
	if ( (fp = popen(user_add,"w")) == NULL)
	{
	    free(user_add);
    	    return;
	}
	pclose(fp);
	strcpy(info_buffer, "The user nobody has been added to your system\n");
	strcat(info_buffer, "with a /bin/false shell and put in /etc/ftpusers\n");
	strcat(info_buffer, "Note, it was not passworded.\n");
	info_window = create_info_window ();
	gtk_widget_show (info_window);
    }

    /* Set version in the version entry */
    versionbuffer=(char *)malloc(8192);  
    bzero(versionbuffer, 8192);
    if( (fp = popen("proftpd -v 2>&1 |awk '{print \"Proftpd version: \",$4}' |tr -d \"\r\n\"", "r"))==NULL)
    {
        strcpy(info_buffer, "Cant get status from \"proftpd -v\".\n");
        strcat(info_buffer, "Run GProFTPD as root.\n");
        strcat(info_buffer, "Have you installed ProFTPD ?.\n");
        info_window = create_info_window ();
        gtk_widget_show (info_window);
        return; 
    }
    fflush(fp);
    while((fgets(versionbuffer, 4096, fp)!=NULL))
    {
    }
    version_entry = lookup_widget (GTK_WIDGET (widget), "version_entry");
    utf8 = g_locale_to_utf8(versionbuffer, strlen(versionbuffer), NULL, NULL, NULL);
    gtk_entry_set_text(GTK_ENTRY (version_entry), utf8);
    pclose(fp);
    free(versionbuffer);
    if(utf8 !=NULL)
    g_free(utf8);

    /* List the transferred files tab */
    if( (fp = fopen("/var/log/xferlog", "r")) == NULL)
    {
       strcpy(info_buffer, "Cant find /var/log/xferlog.\n\n");
       strcat(info_buffer, "If youre running GProFTPD as root\n");
       strcat(info_buffer, "the xferlog has been added for you.\n");
       info_window = create_info_window();
       gtk_widget_show(info_window);
       system("touch /var/log/xferlog");
    }
    else
      fclose(fp);

    if( (fp = fopen("/var/log/xferlog", "r")) == NULL)
    {
	printf("\nopening /var/log/xferlog failed\n");
	return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    get_buffer=(char *)malloc(size_buffer+8192);  
    bzero(get_buffer, size_buffer+8192);
    file_buffer=(char *)malloc(size_buffer+8192);
    bzero(file_buffer, size_buffer+8192);
    while (fgets(file_buffer, size_buffer+8192, fp)!=NULL)
    {
	strcat(get_buffer, file_buffer);
    }
    strcat(get_buffer, "\n");
    utf8 = g_locale_to_utf8(get_buffer, strlen(get_buffer), NULL, NULL, NULL);
    file_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(files_textview));
    gtk_text_buffer_set_text(file_text_buffer, utf8, strlen(utf8));
    fclose(fp);
    free(file_buffer);
    free(get_buffer);
    if(utf8 !=NULL)
    g_free(utf8);

    /* Setup the userlist */
    user_model = gtk_list_store_new(5, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
    gtk_tree_view_set_model(GTK_TREE_VIEW(userlist_treeview), GTK_TREE_MODEL (user_model));
    cell = gtk_cell_renderer_text_new();
    user_column = gtk_tree_view_column_new_with_attributes("User", cell, "text", 0, NULL);
    group_column = gtk_tree_view_column_new_with_attributes("Group", cell, "text", 1, NULL);
    maxclients_column = gtk_tree_view_column_new_with_attributes("Home directory", cell, "text", 2, NULL);
    require_column = gtk_tree_view_column_new_with_attributes("Require password", cell, "text", 3, NULL);
    maximum_column = gtk_tree_view_column_new_with_attributes("Maximum simultaneous connections", cell, "text", 4, NULL);
    gtk_list_store_clear(user_model);
    gtk_tree_view_append_column(GTK_TREE_VIEW(userlist_treeview), GTK_TREE_VIEW_COLUMN(user_column));
    gtk_tree_view_append_column(GTK_TREE_VIEW(userlist_treeview), GTK_TREE_VIEW_COLUMN(group_column));
    gtk_tree_view_append_column(GTK_TREE_VIEW(userlist_treeview), GTK_TREE_VIEW_COLUMN(maxclients_column));
    gtk_tree_view_append_column(GTK_TREE_VIEW(userlist_treeview), GTK_TREE_VIEW_COLUMN(require_column));
    gtk_tree_view_append_column(GTK_TREE_VIEW(userlist_treeview), GTK_TREE_VIEW_COLUMN(maximum_column));
    

    /* Add all available shells to the loginshell combo */
    shell_combo = lookup_widget(GTK_WIDGET (widget), "shell_combo");
    if( (fp = fopen("/etc/shells", "r"))==NULL)
    {
        printf("Cant open /etc/shells for reading\n");
    }
    else
      {   
         fseek(fp, 0, SEEK_END);
         size_buffer = ftell(fp);
         rewind(fp);
         shell=(char *)malloc(size_buffer);
         bzero(shell, sizeof(char) * size_buffer);
         new_buffer=(char *)malloc(size_buffer);
         bzero(new_buffer, sizeof(char) * size_buffer);
         utf8=g_locale_to_utf8("/bin/false", 10, NULL, NULL, NULL);
         items = g_list_append (items, utf8);
         while (fgets(shell, size_buffer, fp)!=NULL) 
         {
            if( strstr(shell, "/") && ! strstr(shell, "/bin/false") )
            {
                sscanf(shell, "%s", new_buffer);
                utf8=g_locale_to_utf8(new_buffer, strlen(new_buffer), NULL, NULL, NULL);
                items = g_list_append (items, utf8);
            }
         }
         fclose(fp);
         free(shell);
         free(new_buffer);
         gtk_combo_set_popdown_strings(GTK_COMBO(shell_combo), items);
         if(utf8 !=NULL)
         g_free(utf8);
    }

    /* List the security tabs */
    if( (fp = fopen("/var/log/secure", "r")) == NULL) 
    {
	strcpy(info_buffer, "Couldnt find /var/log/secure\n");
	strcat(info_buffer, "so i added it.\n");
	system("touch /var/log/secure");
	info_window = create_info_window ();
	gtk_widget_show (info_window);
    }
    else
      {
	 fseek(fp, 0, SEEK_END);
	 size_buffer = ftell(fp);
	 rewind(fp);
	 buffer=(char *)malloc(size_buffer+1024);
	 bzero(buffer, size_buffer+1024);
	 get_buffer=(char *)malloc(size_buffer+1024);
	 bzero(get_buffer, size_buffer+1024);
	 while(fgets(buffer, size_buffer, fp)!=NULL)
	 {
	    if( strstr(buffer, "Login successful") )
	    {
		strcat(get_buffer, buffer);
	    }
	 }
	 security_successful_textview = lookup_widget (GTK_WIDGET (widget), "security_successful_textview");
	 security_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(security_successful_textview));
	 utf8 = g_locale_to_utf8(get_buffer, strlen(get_buffer), NULL, NULL, NULL);
	 gtk_text_buffer_set_text(security_text_buffer, utf8, strlen(utf8));
	 fclose(fp);
	 free(buffer);
	 free(get_buffer);
    }

    if( (fp = fopen("/var/log/secure", "r")) == NULL) 
    {
	strcpy(info_buffer, "Couldnt find /var/log/secure\n\n");
	strcat(info_buffer, "Run GProFTPD as root.\n");
        info_window = create_info_window ();
        gtk_widget_show (info_window);
    }
    else
      {
	 fseek(fp, 0, SEEK_END);
	 size_buffer = ftell(fp);
	 rewind(fp);
	 buffer=(char *)malloc(size_buffer+1024);
	 bzero(buffer, size_buffer+1024);
	 get_buffer=(char *)malloc(size_buffer+1024);
	 bzero(get_buffer, size_buffer+1024);   
	 while(fgets(buffer, size_buffer, fp)!=NULL)
	 {
	    if( strstr(buffer, "Login failed") )
	    {
    		strcat(get_buffer, buffer);
    	    }
    	    if( strstr(buffer, "refused") )
    	    {
    		strcat(get_buffer, buffer);
    	    }
    	    if( strstr(buffer, "no such user") )
    	    {
    		strcat(get_buffer, buffer);
    	    }
    	    if( strstr(buffer, "Maximum login attempts") )
    	    {
        	strcat(get_buffer, buffer);
    	    }
    	    if( strstr(buffer, "SECURITY VIOLATION") )
    	    {
        	strcat(get_buffer, buffer);
    	    }
	 }
	 security_refused_textview = lookup_widget (GTK_WIDGET (widget), "security_refused_textview");
    	 security_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(security_refused_textview));
    	 utf8 = g_locale_to_utf8(get_buffer, strlen(get_buffer), NULL, NULL, NULL);
    	 gtk_text_buffer_set_text(security_text_buffer, utf8, strlen(utf8));
    	 fclose(fp);
    	 if(utf8 !=NULL)
    	 g_free(utf8);
    	 free(buffer);
    	 free(get_buffer);
      }


    /* List the disc tab */
    disc_model = gtk_list_store_new(6, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
    gtk_tree_view_set_model(GTK_TREE_VIEW(disc_treeview), GTK_TREE_MODEL (disc_model));
    cell = gtk_cell_renderer_text_new();
    gtk_list_store_clear(disc_model);
    mount_column = gtk_tree_view_column_new_with_attributes("Mounted on", cell, "text", 0, NULL);
    free_column = gtk_tree_view_column_new_with_attributes("Free space", cell, "text", 1, NULL);
    used_column = gtk_tree_view_column_new_with_attributes("Used space", cell, "text", 2, NULL);
    total_column = gtk_tree_view_column_new_with_attributes("Total space", cell, "text", 3, NULL);
    percent_column = gtk_tree_view_column_new_with_attributes("Percent used", cell, "text", 4, NULL);
    device_column = gtk_tree_view_column_new_with_attributes("Device", cell, "text", 5, NULL);
    if ( (fp = popen("df -h |grep /", "r")) == NULL)
    {
	printf("Error running df -h\n");
        return;
    }
    else
      {
	 /* stdio FILE streams are buffered */
	 fflush(fp);
	 buffer=(char *)malloc(8192);
	 bzero(buffer, 8192);   
    	 device=(char *)malloc(8192);
	 bzero(device, 8192);   
	 total=(char *)malloc(8192);
	 bzero(total, 8192);   
	 used=(char *)malloc(8192);
	 bzero(used, 8192);   
	 disc_free=(char *)malloc(8192);
	 bzero(disc_free, 8192);   
	 percent=(char *)malloc(8192);
         bzero(percent, 8192);   
	 mount=(char *)malloc(8192);
	 bzero(mount, 8192);   
         while(fgets(buffer, 8192, fp)!=NULL)
         {
    	    sscanf(buffer, "%s %s %s %s %s %s", device, total, used, disc_free, percent, mount);
    	    gtk_list_store_append(GTK_LIST_STORE(disc_model), &iter);
    	    utf8 = g_locale_to_utf8(mount, strlen(mount), NULL, NULL, NULL);
    	    gtk_list_store_set(GTK_LIST_STORE(disc_model), &iter, 0, utf8, -1);
    	    utf8 = g_locale_to_utf8(disc_free, strlen(disc_free), NULL, NULL, NULL);
    	    gtk_list_store_set(GTK_LIST_STORE(disc_model), &iter, 1, utf8, -1);
    	    utf8 = g_locale_to_utf8(used, strlen(used), NULL, NULL, NULL);
    	    gtk_list_store_set(GTK_LIST_STORE(disc_model), &iter, 2, utf8, -1);
    	    utf8 = g_locale_to_utf8(total, strlen(total), NULL, NULL, NULL);
    	    gtk_list_store_set(GTK_LIST_STORE(disc_model), &iter, 3, utf8, -1);
    	    utf8 = g_locale_to_utf8(percent, strlen(percent), NULL, NULL, NULL);
    	    gtk_list_store_set(GTK_LIST_STORE(disc_model), &iter, 4, utf8, -1);
    	    utf8 = g_locale_to_utf8(device, strlen(device), NULL, NULL, NULL);
	    gtk_list_store_set(GTK_LIST_STORE(disc_model), &iter, 5, utf8, -1);
         }
         gtk_tree_view_append_column(GTK_TREE_VIEW(disc_treeview), GTK_TREE_VIEW_COLUMN(mount_column));
         gtk_tree_view_append_column(GTK_TREE_VIEW(disc_treeview), GTK_TREE_VIEW_COLUMN(free_column));
         gtk_tree_view_append_column(GTK_TREE_VIEW(disc_treeview), GTK_TREE_VIEW_COLUMN(used_column));
         gtk_tree_view_append_column(GTK_TREE_VIEW(disc_treeview), GTK_TREE_VIEW_COLUMN(total_column));
         gtk_tree_view_append_column(GTK_TREE_VIEW(disc_treeview), GTK_TREE_VIEW_COLUMN(percent_column));
         gtk_tree_view_append_column(GTK_TREE_VIEW(disc_treeview), GTK_TREE_VIEW_COLUMN(device_column));
         pclose(fp);
         if(utf8 !=NULL)
         g_free(utf8);
         free(buffer);
         free(device);   
         free(total);   
         free(used);   
         free(disc_free);   
         free(percent);   
         free(mount);   
      }

    /* List the banned users, if no /etc/ftpusers one is created and all existing users put there (security). */
    banned_textview = lookup_widget (GTK_WIDGET (widget), "banned_textview");
    if( (fp = fopen("/etc/ftpusers", "r")) == NULL )
    {
	strcpy(info_buffer, "Couldnt find /etc/ftpusers\n");
        strcat(info_buffer, "so i made that file and added\n");
        strcat(info_buffer, "all the users on the system to it.\n");
        strcat(info_buffer, "This in an auto security feature.\n");
        info_window = create_info_window ();
        gtk_widget_show (info_window);
        system("cat /etc/passwd |cut -f1 -d\":\" > /etc/ftpusers");
    }
    else
    fclose(fp);

    
    if( (fp = fopen("/etc/ftpusers", "r")) == NULL )
    {
        strcpy(info_buffer, "Couldnt find /etc/ftpusers\n");
        strcat(info_buffer, "Run GProFTPD as root.\n");
        info_window = create_info_window ();
        gtk_widget_show (info_window);
        return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    buffer=(char *)malloc(size_buffer);
    bzero(buffer, sizeof(char) * size_buffer);
    get_buffer=(char *)malloc(size_buffer);
    bzero(get_buffer, sizeof(char) * size_buffer);
    while (fgets(buffer, size_buffer, fp)!=NULL)
    {
	strcat(get_buffer, buffer);
    }
    text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(banned_textview));
    utf8 = g_locale_to_utf8(get_buffer, strlen(get_buffer), NULL, NULL, NULL);
    gtk_text_buffer_set_text(text_buffer, utf8, strlen(utf8));
    fclose (fp);
    free(buffer);
    free(get_buffer);
    if(utf8 !=NULL)
    g_free(utf8);
    
    /* Start the timers */
    incoming_entry = lookup_widget (GTK_WIDGET (widget), "incoming_entry");
    outgoing_entry = lookup_widget (GTK_WIDGET (widget), "outgoing_entry");
    status_entry = lookup_widget (GTK_WIDGET (widget), "status_entry");
    usage_textview = lookup_widget (GTK_WIDGET (widget), "usage_textview");
    gtk_timeout_add( 1000, (GtkFunction) usage_update, usage_textview);
    gtk_timeout_add( 1000, (GtkFunction) speed_update, usage_textview);

    /* Update the relevant tabs */
    list_global(status_entry, NULL);
    list_entire(status_entry, NULL);
    list_users(userlist_treeview, NULL);
}


void
on_online_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
    system("rm -f /etc/shutmsg");
    system("proftpd -c /etc/proftpd.conf");
}


void
on_offline_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
    system("killall -9 proftpd");
}


void
on_reread_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
    system("killall -1 proftpd");
}


void
on_shutdown_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
    GtkWidget *shutdown_window;
    shutdown_window=create_shutdown_window();
    gtk_widget_show(shutdown_window);
}


void
on_help_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
    GtkWidget *help_window;
    help_window=create_help_window();
    gtk_widget_show(help_window);
}


void
on_credits_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
    GtkWidget *credits_window;
    credits_window=create_credits_window();
    gtk_widget_show(credits_window);
}


void
on_global_apply_button_clicked  (GtkButton       *button,
                                gpointer         user_data)
{
    /* The Global tabs change_button. */
    FILE *fp;
    char *szBuffer;
    char *edited_config;
    char *profile_buffer;
    char *change_srv_ident;
    long size_buffer;
    int change=1;
    GtkWidget *info_window;
    GtkWidget *entire_textview;
    GtkWidget *global_server_name;
    GtkWidget *global_server_admin_email;
    GtkWidget *global_server_port;
    GtkWidget *global_max_connect;
    GtkWidget *global_idle_timeout;
    GtkWidget *global_resume_uploads;
    GtkWidget *global_resume_downloads;
    GtkWidget *global_download_bandwidth;
    GtkWidget *global_upload_bandwidth;
    GtkWidget *global_show_server_identity;
    GtkWidget *global_show_server_identity_on_off;
    GtkWidget *global_reverse_lookups;
    GtkWidget *global_default_transfer_mode;
    GtkWidget *global_ident_lookups;
    GtkWidget *global_allow_fxp;
    GtkWidget *global_server_user;
    GtkWidget *global_server_group;
    GtkWidget *global_time_standard;
    GtkWidget *global_max_login_attempts;
    GtkWidget *global_timeout_login;
    GtkWidget *global_delete_aborted_stores;
    G_CONST_RETURN gchar *current_change_name;
    G_CONST_RETURN gchar *current_change_server_admin;
    G_CONST_RETURN gchar *current_change_port;
    G_CONST_RETURN gchar *current_change_max_connect;
    G_CONST_RETURN gchar *current_change_no_transfer;
    G_CONST_RETURN gchar *current_change_identity;
    G_CONST_RETURN gchar *current_change_identity_on_off;
    G_CONST_RETURN gchar *current_change_transfer_mode;
    G_CONST_RETURN gchar *current_change_ident_lookups;
    G_CONST_RETURN gchar *current_change_reverse_lookups;
    G_CONST_RETURN gchar *current_change_server_user;
    G_CONST_RETURN gchar *current_change_server_group;
    G_CONST_RETURN gchar *current_change_allow_fxp;
    G_CONST_RETURN gchar *current_change_time_standard;
    G_CONST_RETURN gchar *current_change_max_login_attempts;
    G_CONST_RETURN gchar *current_change_timeout_login;
    G_CONST_RETURN gchar *current_change_resume_dl;
    G_CONST_RETURN gchar *current_change_download_bandwidth;
    G_CONST_RETURN gchar *current_change_resume_ul;
    G_CONST_RETURN gchar *current_change_upload_bandwidth;
    G_CONST_RETURN gchar *current_change_delete_aborted_stores;
    global_server_name = lookup_widget (GTK_WIDGET (button), "global_server_name");
    global_server_admin_email = lookup_widget (GTK_WIDGET (button), "global_server_admin_email");    
    global_server_port = lookup_widget (GTK_WIDGET (button), "global_server_port");
    global_max_connect = lookup_widget (GTK_WIDGET (button), "global_max_connect");
    global_idle_timeout = lookup_widget (GTK_WIDGET (button), "global_idle_timeout");
    global_resume_uploads = lookup_widget (GTK_WIDGET (button), "global_resume_uploads");
    global_resume_downloads = lookup_widget (GTK_WIDGET (button), "global_resume_downloads");
    global_download_bandwidth = lookup_widget (GTK_WIDGET (button), "global_download_bandwidth");
    global_upload_bandwidth = lookup_widget (GTK_WIDGET (button), "global_upload_bandwidth");
    global_show_server_identity = lookup_widget (GTK_WIDGET (button), "global_show_server_identity");
    global_show_server_identity_on_off = lookup_widget (GTK_WIDGET (button), "global_show_server_identity_on_off");
    global_reverse_lookups = lookup_widget (GTK_WIDGET (button), "global_reverse_lookups");
    global_default_transfer_mode = lookup_widget (GTK_WIDGET (button), "global_default_transfer_mode");
    global_ident_lookups = lookup_widget (GTK_WIDGET (button), "global_ident_lookups");
    global_allow_fxp = lookup_widget (GTK_WIDGET (button), "global_allow_fxp");
    global_server_user = lookup_widget (GTK_WIDGET (button), "global_server_user");
    global_server_group = lookup_widget (GTK_WIDGET (button), "global_server_group");
    global_time_standard = lookup_widget (GTK_WIDGET (button), "global_time_standard");
    global_max_login_attempts = lookup_widget (GTK_WIDGET (button), "global_max_login_attempts");
    global_timeout_login = lookup_widget (GTK_WIDGET (button), "global_timeout_login");
    global_delete_aborted_stores = lookup_widget (GTK_WIDGET (button), "global_delete_aborted_stores");
    entire_textview = lookup_widget (GTK_WIDGET (button), "entire_textview");
    current_change_name = gtk_entry_get_text(GTK_ENTRY(global_server_name));
    current_change_server_admin = gtk_entry_get_text(GTK_ENTRY(global_server_admin_email));
    current_change_port = gtk_entry_get_text(GTK_ENTRY(global_server_port));
    current_change_max_connect = gtk_entry_get_text(GTK_ENTRY(global_max_connect));
    current_change_no_transfer = gtk_entry_get_text(GTK_ENTRY(global_idle_timeout));
    current_change_resume_ul = gtk_entry_get_text(GTK_ENTRY(global_resume_uploads));
    current_change_resume_dl = gtk_entry_get_text(GTK_ENTRY(global_resume_downloads));
    current_change_upload_bandwidth = gtk_entry_get_text(GTK_ENTRY(global_upload_bandwidth));
    current_change_download_bandwidth = gtk_entry_get_text(GTK_ENTRY(global_download_bandwidth));
    current_change_identity = gtk_entry_get_text(GTK_ENTRY(global_show_server_identity));
    current_change_identity_on_off = gtk_entry_get_text(GTK_ENTRY(global_show_server_identity_on_off));
    current_change_reverse_lookups = gtk_entry_get_text(GTK_ENTRY(global_reverse_lookups));
    current_change_transfer_mode = gtk_entry_get_text(GTK_ENTRY(global_default_transfer_mode));
    current_change_ident_lookups = gtk_entry_get_text(GTK_ENTRY(global_ident_lookups));
    current_change_server_user = gtk_entry_get_text(GTK_ENTRY(global_server_user));
    current_change_server_group = gtk_entry_get_text(GTK_ENTRY(global_server_group));
    current_change_allow_fxp = gtk_entry_get_text(GTK_ENTRY(global_allow_fxp));
    current_change_time_standard = gtk_entry_get_text(GTK_ENTRY(global_time_standard));
    current_change_max_login_attempts = gtk_entry_get_text(GTK_ENTRY(global_max_login_attempts));
    current_change_timeout_login = gtk_entry_get_text(GTK_ENTRY(global_timeout_login));
    current_change_delete_aborted_stores = gtk_entry_get_text(GTK_ENTRY(global_delete_aborted_stores));
    if( (fp = fopen("/etc/proftpd.conf", "r")) == NULL)
    {
    	strcpy(info_buffer, "Cant open /etc/proftpd.conf\n");
    	info_window = create_info_window();
    	gtk_widget_show(info_window);
    	return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    change_srv_ident=(char *)malloc(1024);        
    bzero(change_srv_ident, 1024); 
    profile_buffer=(char *)malloc(size_buffer + 4096);
    bzero(profile_buffer, size_buffer + 4096);
    edited_config=(char *)malloc(size_buffer + 4096);
    bzero(edited_config, size_buffer + 4096);
    szBuffer=(char *)malloc(size_buffer + 4096);        
    bzero(szBuffer, size_buffer + 4096); 

    while(fgets(szBuffer, size_buffer, fp)!=NULL)
    {
	/* Make changes until the first profile is found */
	if( strstr(szBuffer, "<") )
	change=0;
	
    	if( change )
    	{          	
	    if( strstr(szBuffer, "ServerName") )
    	    {          	
        	sprintf(szBuffer, "ServerName \"%s\"\n",current_change_name );
        	strcat(edited_config, szBuffer);
    	    }
    	    if( strstr(szBuffer, "ServerAdmin") )
    	    {
        	sprintf(szBuffer, "ServerAdmin %s\n",current_change_server_admin );
        	strcat(edited_config, szBuffer);
    	    }
	    /* Dont match with usepassiveports  */
    	    if( strstr(szBuffer, "Port ") )
    	    {
        	sprintf(szBuffer, "Port %s\n",current_change_port );
        	strcat(edited_config, szBuffer);
    	    }
    	    if( strstr(szBuffer, "MaxInstances") )
    	    {
	        sprintf(szBuffer, "MaxInstances %s\n",current_change_max_connect);
                strcat(edited_config, szBuffer);
    	    }
    	    if( strstr(szBuffer, "TimeoutNoTransfer") )
    	    {
	        sprintf(szBuffer, "TimeoutNoTransfer %s\n",current_change_no_transfer);
                strcat(edited_config, szBuffer);
	    }
    	    if( strstr(szBuffer, "AllowStoreRestart") )
    	    {
	        sprintf(szBuffer, "AllowStoreRestart %s\n",current_change_resume_ul);
                strcat(edited_config, szBuffer);
	    }
    	    if( strstr(szBuffer, "AllowRetrieveRestart") )
	    {
	        sprintf(szBuffer, "AllowRetrieveRestart %s\n",current_change_resume_dl);
                strcat(edited_config, szBuffer);
	    }
    	    if( strstr(szBuffer, "TransferRate RETR") )
	    {
	        sprintf(szBuffer, "TransferRate RETR %s\n",current_change_download_bandwidth);
                strcat(edited_config, szBuffer);
	    }
    	    if( strstr(szBuffer, "TransferRate STOR") )
	    {
	        sprintf(szBuffer, "TransferRate STOR %s\n",current_change_upload_bandwidth);
                strcat(edited_config, szBuffer);
	    }
    	    if( strstr(szBuffer, "TransferRate APPE") )
	    {
	        sprintf(szBuffer, "TransferRate APPE %s\n",current_change_upload_bandwidth);
                strcat(edited_config, szBuffer);
	    }
    	    if( strstr(szBuffer, "TransferRate STOU") )
	    {
	        sprintf(szBuffer, "TransferRate STOU %s\n",current_change_upload_bandwidth);
                strcat(edited_config, szBuffer);
	    }
    	    if( strstr(szBuffer, "ServerIdent") )
	    {
        	strcat(change_srv_ident, current_change_identity_on_off);
		strcat(change_srv_ident, " \"");
		strcat(change_srv_ident, current_change_identity);
		strcat(change_srv_ident, "\"");
		sprintf(szBuffer, "ServerIdent %s\n",change_srv_ident);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "UseReverseDNS") )
	    {
		sprintf(szBuffer, "UseReverseDNS %s\n",current_change_reverse_lookups);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "IdentLookups") )
	    {
		sprintf(szBuffer, "IdentLookups %s\n",current_change_ident_lookups);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "DefaultTransferMode") )
	    {
		sprintf(szBuffer, "DefaultTransferMode %s\n",current_change_transfer_mode);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "User") ) 
	    {
		sprintf(szBuffer, "User %s\n",current_change_server_user);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "Group") )
	    {
		sprintf(szBuffer, "Group %s\n",current_change_server_group);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "AllowForeignAddress") )
	    {
		sprintf(szBuffer, "AllowForeignAddress %s\n",current_change_allow_fxp);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "TimesGMT") )
	    {
		sprintf(szBuffer, "TimesGMT %s\n",current_change_time_standard);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "MaxLoginAttempts") )
	    {
		sprintf(szBuffer, "MaxLoginAttempts %s\n",current_change_max_login_attempts);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "TimeoutLogin") )
	    {
		sprintf(szBuffer, "TimeoutLogin %s\n",current_change_timeout_login);
        	strcat(edited_config, szBuffer);
	    }
            if( strstr(szBuffer, "DeleteAbortedStores") )
	    {
	        sprintf(szBuffer, "DeleteAbortedStores %s\n",current_change_delete_aborted_stores);
                strcat(edited_config, szBuffer);
	    }
	}
	/* Gathering all the lines */
        strcat(profile_buffer, szBuffer);

    }
    fclose(fp);
    free(szBuffer);
    free(change_srv_ident);


    /* Write the edited configuration to proftpd.conf */
    if( (fp = fopen("/etc/proftpd.conf", "w+")) == NULL)
    {
	strcpy(info_buffer, "Cant open /etc/proftpd.conf for writing\n");
        info_window = create_info_window();
        gtk_widget_show(info_window);
        free(edited_config);
	free(profile_buffer);
        return;
    }
    strcpy(edited_config, profile_buffer);
    fputs(edited_config, fp);
    fclose(fp);
    free(edited_config);
    free(profile_buffer);
    userlist_treeview = lookup_widget (GTK_WIDGET (button), "userlist_treeview");
    entire_textview = lookup_widget (GTK_WIDGET (button), "entire_textview");
    list_users(userlist_treeview, NULL);
    list_entire(userlist_treeview, NULL);
    system("killall -1 proftpd");
}


void
on_useradd_button_clicked  (GtkButton       *button,
                            gpointer         user_data)
{
    /* Adds a new user */
    FILE *fp;
    long size_buffer;
    GtkWidget *info_window;
    GtkWidget *userlist_treeview;
    GtkWidget *entire_textview;
    GtkWidget *useradd_username_entry;
    GtkWidget *useradd_password_entry;
    GtkWidget *useradd_directory_entry;
    GtkWidget *useradd_incoming_directory_entry;
    GtkWidget *useradd_incoming_checkbutton;
    GtkWidget *useradd_shell_entry;
    G_CONST_RETURN gchar *username;
    G_CONST_RETURN gchar *password;
    G_CONST_RETURN gchar *shell;
    G_CONST_RETURN gchar *dir;
    G_CONST_RETURN gchar *incoming;
    char *profile, *check_buffer, *user_check;
    char useradd_command[4096]="";
    char user_pass[4096]="";
    char fix_dir[4096]="";
    int length=0;

    useradd_username_entry = lookup_widget (GTK_WIDGET (button), "useradd_username_entry");
    useradd_password_entry = lookup_widget (GTK_WIDGET (button), "useradd_password_entry");
    useradd_shell_entry = lookup_widget (GTK_WIDGET (button), "useradd_shell_entry");
    useradd_directory_entry = lookup_widget (GTK_WIDGET (button), "useradd_directory_entry");
    useradd_incoming_directory_entry = lookup_widget (GTK_WIDGET (button), "useradd_incoming_directory_entry");
    useradd_incoming_checkbutton = lookup_widget (GTK_WIDGET (button), "useradd_incoming_checkbutton");

    username = gtk_entry_get_text(GTK_ENTRY(useradd_username_entry));
    password = gtk_entry_get_text(GTK_ENTRY(useradd_password_entry));
    shell = gtk_entry_get_text(GTK_ENTRY(useradd_shell_entry));
    dir = gtk_entry_get_text(GTK_ENTRY(useradd_directory_entry));
    incoming = gtk_entry_get_text(GTK_ENTRY(useradd_incoming_directory_entry));

    /* If the username field is empty inform that this cant be done. */
    length = strlen(username = gtk_entry_get_text(GTK_ENTRY(useradd_username_entry)));
    if ( length == 0 ) 
    {
    	strcpy(info_buffer, "You must specify a username.\n");
    	info_window = create_info_window ();
    	gtk_widget_show (info_window);
    	return;
    }

    if ( username[0]=='0'||username[0]=='1'||username[0]=='2'||username[0]=='3'||username[0]=='4' 
    ||username[0]=='5'||username[0]=='6'||username[0]=='7'||username[0]=='8'||username[0]=='9') 
    {
    	strcpy(info_buffer, "Usernames cant begin with a digit (for buggy useradds).\n");
    	info_window = create_info_window ();
    	gtk_widget_show (info_window);
    	return;
    }

    /* If the password field has less then 6 chars we inform that this cant be done */
    length = strlen(password = gtk_entry_get_text(GTK_ENTRY(useradd_password_entry)));
    if ( length < 6 ) 
    {
    	strcpy(info_buffer, "The minimum password length is 6 chars.\n");
    	info_window = create_info_window ();
    	gtk_widget_show (info_window);
    	return;
    }

    /* If the shell field has less then 2 chars we inform that this cant be done */
    length = strlen(shell = gtk_entry_get_text(GTK_ENTRY(useradd_shell_entry)));
    if ( length < 2 )
    {
    	strcpy(info_buffer, "The minimum shell length is 1 char.\n");
    	info_window = create_info_window ();
    	gtk_widget_show (info_window);
    	return;
    }

    /* If the directory field has 0 chars we inform that this cant be done */
    length = strlen(dir = gtk_entry_get_text(GTK_ENTRY(useradd_directory_entry)));
    if ( length == 0 ) 
    {
    	strcpy(info_buffer, "Mimimum directory path length is 1 char.\n");
    	info_window = create_info_window ();
    	gtk_widget_show (info_window);
    	return;
    }

    /* Checks if the user exists in /etc/proftpd.conf if so just show a popup */
    if ( (fp = fopen("/etc/proftpd.conf","r")) == NULL)
    {
    	printf("Error adding user\n");
    	return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    check_buffer=(char *)malloc(size_buffer);
    bzero(check_buffer, size_buffer);
    user_check=(char *)malloc(4096);
    bzero(user_check, sizeof(char) * 4096);

    strcpy(user_check, "User ");
    strcat(user_check, username);
    strcat(user_check, "\n"); /* Similar user confusion */

    while(fgets(check_buffer, size_buffer, fp)!=NULL)
    {
	if( strstr(check_buffer, user_check) )
	{
	    free(user_check);
	    free(check_buffer);
	    fclose(fp);
    	    strcpy(info_buffer, "That user already exists.\n");
    	    info_window = create_info_window ();
    	    gtk_widget_show (info_window);
	    return;
	}
    }
    free(user_check);
    free(check_buffer);
    fclose(fp);

    profile=(char *)malloc(8192);
    bzero(profile, 8192);

    strcpy(profile, "\n\n<Anonymous ");
    strcat(profile, dir);
    strcat(profile, ">\n");
    strcat(profile, "User ");
    strcat(profile, username);
    strcat(profile, "\nGroup ");
    strcat(profile, username);
    strcat(profile, "\n");
    strcat(profile, "AnonRequirePassword on\n");
    strcat(profile, "MaxClients 3 \"The server is full, hosting %m users\"\n");
    strcat(profile, "DisplayLogin welcome.msg\n");
    strcat(profile, "DisplayFirstChdir .msg\n");
    strcat(profile, "<Limit WRITE DELE APPE STOR SITE_CHMOD>\n");
    strcat(profile, " DenyAll\n");
    strcat(profile, "</Limit>\n");


    /* If the add incoming directory checkbutton is selected */
    if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(useradd_incoming_checkbutton)) ) 
    {
	/* If the incoming directory field has no chars we inform that this cant be done */
	length = strlen(incoming = gtk_entry_get_text(GTK_ENTRY(useradd_incoming_directory_entry)));
	if ( length == 0 )
	{
    	    strcpy(info_buffer, "The upload directory must be atleast 1 char.\n");
    	    info_window = create_info_window ();
    	    gtk_widget_show (info_window);
    	    return;
	}
	strcat(profile, "<Directory ");
	strcat(profile, dir);
	strcat(profile, incoming);
	strcat(profile, "/*>\n");
	strcat(profile, "<Limit STOR RETR APPE WRITE>\n");
	strcat(profile, " AllowAll\n");
	strcat(profile, "</Limit>\n");
	strcat(profile, "<Limit DELE SITE_CHMOD>\n");
	strcat(profile, " DenyAll\n");
	strcat(profile, "</Limit>\n");
	strcat(profile, "</Directory>\n");
	strcat(profile, "</Anonymous>\n");
    

	/* Add the system user, also makes the userdir root */
	strcpy(useradd_command, "useradd ");
	strcat(useradd_command, username);
	strcat(useradd_command, " -d ");
	strcat(useradd_command, dir);
	/* Create a login shell or not */
	if( strstr(shell, "nologin") || strstr(shell, "false") || strstr(shell, "dev/null") )
	{
	    strcat(useradd_command, " -c ftp-user -m -s ");
	}
	else
	  {
	     strcat(useradd_command, " -c ftp-user -m -r -s ");
	  }
	  strcat(useradd_command, shell);
	  fp = popen(useradd_command, "r");
	  pclose(fp);


	/* Make the incoming directory */
	strcpy(fix_dir, "mkdir ");
	strcat(fix_dir, dir);
	strcat(fix_dir, incoming);
	if ( (fp = popen(fix_dir, "r")) == NULL)
	{
    	    printf("Mk incoming dir  .. something is broken.\n");
    	    return;
	}
	pclose(fp);
	
	/* Chmod the incoming directory */
	strcpy(fix_dir, "chmod 777 ");
	strcat(fix_dir, dir);
	strcat(fix_dir, incoming);
	if ( (fp = popen(fix_dir, "r")) == NULL)
	{
    	    printf("Chmod dir .. something is broken.\n");
    	    return;
	}
	pclose(fp);

	/* Write the new profile */
	fp = fopen("/etc/proftpd.conf", "a");
	fputs(profile, fp);
	fclose(fp);
	free(profile);
    } 
    else
      {
	 strcat(profile, "</Anonymous>\n");

         /* Write the new profile */
	 fp = fopen("/etc/proftpd.conf", "a");
	 fputs(profile, fp);
	 fclose(fp);
	 free(profile);

	 /* Add the system user, also makes the userdir root */
	 strcpy(useradd_command, "useradd ");
	 strcat(useradd_command, username);
	 strcat(useradd_command, " -d ");
	 strcat(useradd_command, dir);
	 /* Create a login shell or not */
    	 if( strstr(shell, "nologin") || strstr(shell, "false") || strstr(shell, "dev/null") )
	 {
	    strcat(useradd_command, " -c ftp-user -m -s ");
	 }
	 else
	    strcat(useradd_command, " -c ftp-user -m -r -s ");
	 
	 strcat(useradd_command, shell);
	 fp = popen(useradd_command, "r");
	 pclose(fp); 
      }

    
    /* Set the users password */
    strcpy(user_pass, "passwd ");
    strcat(user_pass, username);
    if ( (fp = popen(user_pass,"w")) == NULL)
    {
    	printf("\nError passwording user\n");
    	return;
    }
    usleep(100000);
    fputs(password, fp);
    usleep(100000);
    fseek(fp, 0, SEEK_END);
    fputs(password, fp);
    usleep(100000);
    pclose(fp);


    /* Delete some unused files if this user has a no real login shell */
    if( strstr(shell, "nologin") || strstr(shell, "false") || strstr(shell, "dev/null") )
    {
	strcpy(fix_dir, "rm -f /home/ftp/.bash_profile");
	strcat(fix_dir, " ; rm -f /home/ftp/.bash_logout");
	strcat(fix_dir, " ; rm -f /home/ftp/.bashrc");
	strcat(fix_dir, " ; rm -f /home/ftp/.gtkrc");
	strcat(fix_dir, " ; rm -f /var/spool/mail/");
	strcat(fix_dir, username);
	if ( (fp = popen(fix_dir, "r")) == NULL)
	{
    	    return;
	}
	pclose(fp);
    }
    
    /* Update the userlist and the entire configuration tab. */
    userlist_treeview = lookup_widget (GTK_WIDGET (button), "userlist_treeview");
    entire_textview = lookup_widget (GTK_WIDGET (button), "entire_textview");
    list_users(userlist_treeview, NULL);
    list_entire(entire_textview, NULL);
    /* ReRead */
    system("killall -1 proftpd"); 
}


void
on_username_rand_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Randomize username and put it in the username box */
    GtkWidget *useradd_username_entry;
    char *place[]={"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
         "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
         "1","2","3","4","5","6","7","8","9","1","2","3","4","5","6","7","8","9","1","2","3","4","5","6","7","8",
         "1","2","3","4","5","6","7","8","9","1","2","3","4","5","6","7","8","9","1","2","3","4","5","6","7","8"};
    char username[1024]="";
    int timez=0;
    int i=1;
    /* Make the first random nondigit */
    srand((unsigned)time(NULL));
    while(1)
    {
	timez = rand() % 104;
        if( place[timez]!="1" && place[timez]!="2" && place[timez]!="3" && place[timez]!="4" && place[timez]!="5"
	&&  place[timez]!="6" && place[timez]!="7" && place[timez]!="8" && place[timez]!="9" )
        break;
    }
    strcpy(username, place[timez]);
    timez=0;    
    usleep(100000);
    srand((unsigned)time(NULL));
    while( i < randomize_length )
    {
	timez = rand() % 104;
       	strcat(username, place[timez]);
	i++;
    }
    useradd_username_entry = lookup_widget (GTK_WIDGET (button), "useradd_username_entry");
    gtk_entry_set_text (GTK_ENTRY (useradd_username_entry), username);
    sleep(1);
}


void
on_password_rand_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Randomize password and put it in the password box */
    GtkWidget *useradd_password_entry;
    char *place[]={"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
         "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
         "1","2","3","4","5","6","7","8","9","1","2","3","4","5","6","7","8","9","1","2","3","4","5","6","7","8",
         "1","2","3","4","5","6","7","8","9","1","2","3","4","5","6","7","8","9","1","2","3","4","5","6","7","8"};
    char password[1024]="";
    int timez=0;
    int i=1;
    /* Make a first random nondigit */
    srand((unsigned)time(NULL));
    while(1)
    {
	timez = rand() % 104;
        if( place[timez]!="1" && place[timez]!="2" && place[timez]!="3" && place[timez]!="4" && place[timez]!="5"
	&&  place[timez]!="6" && place[timez]!="7" && place[timez]!="8" && place[timez]!="9" )
        break;
    }
    strcpy(password, place[timez]);
    timez=0;    
    usleep(100000);
    srand((unsigned)time(NULL));
    while( i < randomize_length )
    {
	timez = rand() % 104;
       	strcat(password, place[timez]);
	i++;
    }
    useradd_password_entry = lookup_widget (GTK_WIDGET (button), "useradd_password_entry");
    gtk_entry_set_text (GTK_ENTRY (useradd_password_entry), password);
    sleep(1);
}


void
on_userlist_treeview_row_activated     (GtkTreeView     *treeview,
                                        GtkTreePath     *arg1,
                                        GtkTreeViewColumn *arg2,
                                        gpointer         user_data)
{
   /* If a row in the userlist is doubleclicked show the user_profile_window */
    FILE *fp;
    GtkWidget *info_window;
    GtkWidget *profile_username_entry;
    GtkWidget *profile_group_entry;
    GtkWidget *profile_homedirectory_entry;
    GtkWidget *profile_require_password_entry;
    GtkWidget *profile_max_logins_entry;
    GtkWidget *profile_max_logins_spinbutton;
    GtkWidget *user_profile_window;
    GtkTreeIter iter;
    GtkTreeModel *list_store;
    GtkTreeViewColumn *user_column;
    GtkTreePath *path;
    G_CONST_RETURN gchar *username;
    char *new_buffer, *old_buffer, *user_buffer, *spinval;
    long size_buffer;
    int length=0, found=0, i=0;
    G_CONST_RETURN char *length_buffer;
    userlist_treeview = lookup_widget (GTK_WIDGET (treeview), "userlist_treeview");
    list_store = gtk_tree_view_get_model(GTK_TREE_VIEW(userlist_treeview));
    gtk_tree_view_get_cursor(GTK_TREE_VIEW(userlist_treeview), &path, &user_column);
    gtk_tree_model_get_iter(list_store, &iter, path);
    gtk_tree_model_get(list_store, &iter, 0, &username, -1);

    user_profile_window = create_user_profile_window ();
    gtk_widget_show (user_profile_window);

    user_profile_window = lookup_widget (GTK_WIDGET (user_profile_window), "user_profile_window");
    profile_username_entry = lookup_widget (GTK_WIDGET (user_profile_window), "profile_username_entry");
    profile_group_entry = lookup_widget (GTK_WIDGET (user_profile_window), "profile_group_entry");
    profile_homedirectory_entry = lookup_widget (GTK_WIDGET (user_profile_window), "profile_homedirectory_entry");
    profile_require_password_entry = lookup_widget (GTK_WIDGET (user_profile_window), "profile_require_password_entry");
    profile_max_logins_entry = lookup_widget (GTK_WIDGET (user_profile_window), "profile_max_logins_entry");
    profile_max_logins_spinbutton = lookup_widget (GTK_WIDGET (user_profile_window), "profile_max_logins_spinbutton");

    if ((fp = fopen("/etc/proftpd.conf", "r")) == NULL)
    {
        info_window = create_info_window ();
        gtk_widget_show (info_window);       
        return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);

    old_buffer=(char *)malloc(size_buffer);
    bzero(old_buffer, size_buffer);
    new_buffer=(char *)malloc(size_buffer);   
    bzero(new_buffer, size_buffer);
    user_buffer=(char *)malloc(4096);
    bzero(user_buffer, 4096);
    spinval=(char *)malloc(1024);
    bzero(spinval, 1024);

    sprintf(user_buffer, "User %s", username);
    strcat(user_buffer, "\n"); /* Dont delete a similar user */

    /* First of all .. get the home directory */
    while(fgets(old_buffer, size_buffer, fp)!=NULL)
    {                                              
       if ( strstr(old_buffer, user_buffer)!=NULL)
       {
           if ( strlen(old_buffer)>0 )    
           {
	       old_buffer[strlen(old_buffer)-2] = 0;
	       gtk_entry_set_text(GTK_ENTRY(profile_homedirectory_entry), &new_buffer[11]);
               length_buffer = gtk_entry_get_text(GTK_ENTRY(profile_homedirectory_entry));
               length = strlen(length_buffer);
               gtk_editable_delete_text(GTK_EDITABLE(profile_homedirectory_entry), length -2, length);
	       break;
           }
       }
       strcpy(new_buffer, old_buffer);
    }

    rewind(fp);
    while(fgets(old_buffer, size_buffer, fp)!=NULL)
    {
	if( strstr(old_buffer, user_buffer) )
	{
	    found=1;	    
            strcpy(new_buffer, old_buffer);
            gtk_entry_set_text(GTK_ENTRY (profile_username_entry), &new_buffer[5]);
	    length_buffer = gtk_entry_get_text(GTK_ENTRY(profile_username_entry));
            length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(profile_username_entry), length -1, length);
    	}
        if( strstr(old_buffer, "Group") && found ) 
        {
            strcpy(new_buffer, old_buffer);
            gtk_entry_set_text(GTK_ENTRY (profile_group_entry), &new_buffer[6]);
	    length_buffer = gtk_entry_get_text(GTK_ENTRY(profile_group_entry));
            length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(profile_group_entry), length -1, length);
        }
        if( strstr(old_buffer, "AnonRequirePassword") && found ) 
        {
            strcpy(new_buffer, old_buffer);
            gtk_entry_set_text(GTK_ENTRY (profile_require_password_entry), &new_buffer[20]);
	    length_buffer = gtk_entry_get_text(GTK_ENTRY(profile_require_password_entry));
            length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(profile_require_password_entry), length -1, length);
        }
        if( strstr(old_buffer, "MaxClients") && found )
        {
            strcpy(new_buffer, old_buffer);
	    for(i=0; new_buffer[i]; i++)
	    {
		if( new_buffer[i-1]=='"' )
		{
        	    gtk_entry_set_text(GTK_ENTRY (profile_max_logins_entry), &new_buffer[i]);
		    break;
		}
		if( i>100 )
		break;
	    }	    
	    length_buffer = gtk_entry_get_text(GTK_ENTRY(profile_max_logins_entry));
            length = strlen(length_buffer);
            gtk_editable_delete_text(GTK_EDITABLE(profile_max_logins_entry), length -2, length);
	    sscanf(new_buffer, "%*s %s", spinval);
            gtk_entry_set_text(GTK_ENTRY(profile_max_logins_spinbutton), spinval);
        }
        if( strstr(old_buffer, "</Anonymous>") && found )
        { 
    	    break;    
	}
    }
    fclose(fp);
    free(old_buffer);
    free(new_buffer);
    free(user_buffer);
    free(spinval);
    gtk_tree_path_free(path);
}


void
on_userdel_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
    /*  Delete the user and profile and strip excessive whitespace */
    FILE *fp;
    GtkWidget *info_window;
    GtkWidget *profile_username_entry;
    GtkWidget *user_profile_window;
    long size_buffer;
    G_CONST_RETURN gchar *username;
    char *szLineBuffer;
    char *szUserBuffer;
    char *userdel_buffer;
    char *UserUsername;
    char *config;
    int length=0;

    user_profile_window = lookup_widget(GTK_WIDGET(button), "user_profile_window");
    profile_username_entry = lookup_widget(GTK_WIDGET(button), "profile_username_entry");
    username = gtk_entry_get_text(GTK_ENTRY(profile_username_entry));

    /* If the namefield in username is empty inform that we refuse to do anything */
    length = strlen(username);
    if ( length == 0 ) 
    {
       strcpy(info_buffer, "\nThe profile didnt exist.\n");
       info_window = create_info_window ();
       gtk_widget_show (info_window);
       return;
    }
    userdel_buffer=(char *)malloc(4096);
    bzero(userdel_buffer, 4096);   
    strcpy(userdel_buffer, "userdel ");
    strcat(userdel_buffer, username);
    if ( (fp = popen(userdel_buffer, "r")) == NULL)
    {
       printf("Manually delete that user, couldnt delete it for some reason\n");
       free(userdel_buffer);
       return;
    }
    pclose(fp);
    free(userdel_buffer);
    UserUsername=(char *)malloc(4096);
    bzero(UserUsername, 4096);   
    strcpy(UserUsername, "User ");
    strcat(UserUsername, username);

    /* Avoid similar user deletion */
    strcat(UserUsername, "\n");

    /* Delete the configuration for the deleted user */
    if ( (fp = fopen("/etc/proftpd.conf", "r")) == NULL)
    {
       strcpy(info_buffer, "Cant open /etc/proftpd.conf\n");
       strcat(info_buffer, "Run GProFTPD as root\n");
       free(UserUsername);
       info_window = create_info_window ();
       gtk_widget_show (info_window);
       return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    
    /* This will also hold 1 newline char per user (so the conf will be nice to read) 
     * +200000 will make it hold 100000 users
     */

    config=(char *)malloc(size_buffer+200000); 
    bzero(config, size_buffer+200000);

    szLineBuffer=(char *)malloc(size_buffer);
    szUserBuffer=(char *)malloc(size_buffer);
    bzero(szLineBuffer, size_buffer);
    bzero(szUserBuffer, size_buffer);
    while(fgets(szLineBuffer, size_buffer, fp) !=NULL)
    {
        if (strstr(szLineBuffer, "<Anonymous ") )  
        {
            strcpy(szUserBuffer, szLineBuffer);        
	    	    
            while( strstr(szLineBuffer, "</Anonymous>")==NULL ) 
	    {
	       if( fgets(szLineBuffer, size_buffer, fp)==NULL )
	       {
		   break;
	       }
               strcat(szUserBuffer, szLineBuffer); 
	    }
            if( strstr(szUserBuffer, UserUsername)==NULL )
            {
                strcat(config, szUserBuffer); 
            }
        }
    	else
	  {
	     /* Delete extra whitespace between profiles and get the rest of the values */
	     if( strlen(szLineBuffer)>3 )
	     strcat(config, szLineBuffer);
	  }

	  if( strlen(szLineBuffer)>3 && (strstr(szLineBuffer, "</Anonymous>") || strstr(szLineBuffer, "End of the global") ) )
	  {
	      strcat(config, "\n");
	  }
    } 	  
    fclose(fp);
    free(UserUsername);
    free(szLineBuffer);
    free(szUserBuffer);
    /* Add the new config without the deleted profile */
    if( (fp = fopen("/etc/proftpd.conf", "w+")) == NULL)
    {
        return;
    }
    fputs(config, fp);
    fclose(fp);
    free(config);
    gtk_widget_destroy(user_profile_window);
    list_entire(userlist_treeview, NULL);
    list_users(userlist_treeview, NULL);
    system("killall -1 proftpd");
}


void
on_userchange_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Change the users profile and strip excessive whitespace */
    FILE *fp;
    GtkWidget *info_window;
    GtkWidget *user_profile_window;
    GtkWidget *profile_username_entry;
    GtkWidget *profile_group_entry;
    GtkWidget *profile_require_password_entry;
    GtkWidget *profile_password_entry;
    GtkWidget *profile_homedirectory_entry;
    GtkWidget *profile_max_logins_spinbutton;
    GtkWidget *profile_max_logins_entry;
    long size_buffer;
    char *changed_buffer;
    char *old_buffer;
    char UserUsername[1024]="";
    char *szLineBuffer;
    char *szUserBuffer;
    char *config;
    G_CONST_RETURN gchar *directory_profile_change;
    G_CONST_RETURN gchar *group_profile_change;
    G_CONST_RETURN gchar *require_password_profile_change;
    G_CONST_RETURN gchar *max_clients_profile_change;
    G_CONST_RETURN gchar *max_clients_profile_text_change;
    char passwd_user[1024]="";
    G_CONST_RETURN gchar *password;
    G_CONST_RETURN gchar *username;
    int length=0, i=0;

    user_profile_window = lookup_widget(GTK_WIDGET(button), "user_profile_window");
    profile_password_entry = lookup_widget(GTK_WIDGET(button), "profile_password_entry");
    profile_username_entry = lookup_widget(GTK_WIDGET(button), "profile_username_entry");
    profile_group_entry = lookup_widget(GTK_WIDGET(button), "profile_group_entry");
    profile_require_password_entry = lookup_widget(GTK_WIDGET(button), "profile_require_password_entry");
    profile_homedirectory_entry = lookup_widget(GTK_WIDGET(button), "profile_homedirectory_entry");
    profile_max_logins_spinbutton = lookup_widget(GTK_WIDGET(button), "profile_max_logins_spinbutton");
    profile_max_logins_entry = lookup_widget(GTK_WIDGET(button), "profile_max_logins_entry");
    password = gtk_entry_get_text(GTK_ENTRY(profile_password_entry));
    length = strlen(password);

    /* If the user has written a password thats too short */
    if ( length < 6 && length > 0 )
    {
       strcpy(info_buffer, "\nThe minimum password length is 6 chars.\n");
       info_window = create_info_window ();
       gtk_widget_show (info_window);
       return;
    }

    username = gtk_entry_get_text(GTK_ENTRY(profile_username_entry));

    /* If the user has written a new acceptable password */
    if (length >= 6)
    {
       password = gtk_entry_get_text(GTK_ENTRY(profile_password_entry));
       /* Change the users password */
       strcpy(passwd_user, "passwd ");
       strcat(passwd_user, username);
       if ( (fp = popen(passwd_user,"w")) == NULL)
       {
          strcpy(info_buffer, "Error changing the password.\n");
          info_window = create_info_window ();
          gtk_widget_show (info_window);
       }
       usleep(100000);
       fputs(password, fp);
       usleep(100000);
       fseek(fp, 0, SEEK_END);
       fputs(password, fp);
       usleep(100000);
       pclose(fp);
       strcpy(info_buffer, "\nThe Password was changed.\n");
       info_window = create_info_window ();
       gtk_widget_show (info_window);
    }

    strcpy(UserUsername, "User ");
    strcat(UserUsername, username);
    /* Avoiding similar user deletion */
    strcat(UserUsername, "\n");

    /* Make changes for this users profile */
    if ( (fp = fopen("/etc/proftpd.conf", "r")) == NULL)
    {
       strcpy(info_buffer, "\nCant open /etc/proftpd.conf\n");
       info_window = create_info_window ();
       gtk_widget_show (info_window);
       return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    changed_buffer=(char *)malloc(size_buffer + 4096);
    bzero(changed_buffer, size_buffer + 4096);
    old_buffer=(char *)malloc(size_buffer + 4096);        
    bzero(old_buffer, size_buffer + 4096); 

    while(fgets(old_buffer, size_buffer, fp)!=NULL)
    {
          /* If the username is found, start editing its profile */
          if (strstr(old_buffer, UserUsername)!=NULL)
          {
	     strcpy(changed_buffer, "\n<Anonymous ");
	     strcat(changed_buffer, directory_profile_change = gtk_entry_get_text(GTK_ENTRY(profile_homedirectory_entry)));
             strcat(changed_buffer, ">\n");
	     strcat(changed_buffer, UserUsername);
             strcat(changed_buffer, "Group ");
             strcat(changed_buffer, group_profile_change = gtk_entry_get_text(GTK_ENTRY(profile_group_entry)));
	     strcat(changed_buffer, "\n");
             strcat(changed_buffer, "AnonRequirePassword ");
	     strcat(changed_buffer, require_password_profile_change = gtk_entry_get_text(GTK_ENTRY(profile_require_password_entry)));
	     strcat(changed_buffer, "\n");
	     strcat(changed_buffer, "MaxClients ");
	     strcat(changed_buffer, max_clients_profile_change = gtk_entry_get_text(GTK_ENTRY(profile_max_logins_spinbutton)));
	     strcat(changed_buffer, " \"");
	     strcat(changed_buffer, max_clients_profile_text_change = gtk_entry_get_text(GTK_ENTRY(profile_max_logins_entry)));
	     strcat(changed_buffer, "\"\n");
             i=1;
	  }

          /* Get everything else to the end of the profile at the right place */
          if(i>0) 
	  {
	     i++;
             if(i>5)
             {
	        strcat(changed_buffer, old_buffer);
             }
	  }
	  /* if </Anonymous> stop gathering values */
          if( strstr(old_buffer, "</Anonymous>") && i>1 ) 
	  {
             break;
          }
    }
    fclose(fp);
    free(old_buffer);

    /* Delete the users profile */
    if ( (fp = fopen("/etc/proftpd.conf", "r")) == NULL)
    {
       strcpy(info_buffer, "Cant open /etc/proftpd.conf\n");
       info_window = create_info_window ();
       gtk_widget_show (info_window);
       return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);

    config=(char *)malloc(size_buffer+200000);
    bzero(config, size_buffer+200000);
    szLineBuffer=(char *)malloc(size_buffer);
    bzero(szLineBuffer, size_buffer);
    szUserBuffer=(char *)malloc(size_buffer);
    bzero(szUserBuffer, size_buffer);

    while(fgets(szLineBuffer, size_buffer, fp) !=NULL)
    {
        if( strstr(szLineBuffer, "<Anonymous ") )  
        {
            strcpy(szUserBuffer, szLineBuffer);        
	    	    
            while( strstr(szLineBuffer, "</Anonymous>")==NULL )
	    {
	       if( fgets(szLineBuffer, size_buffer, fp)==NULL )
	       {
		   break;
	       }
               strcat(szUserBuffer, szLineBuffer); 
	    }
            if( strstr(szUserBuffer, UserUsername)==NULL )
            {
                strcat(config, szUserBuffer); 
            }
        }
        else
	  {
		/* Delete extra whitespace between profiles and get the rest of the values */
		if( strlen(szLineBuffer)>3 )
		strcat(config, szLineBuffer);
	  }

	  if( strlen(szLineBuffer)>3 && (strstr(szLineBuffer, "</Anonymous>") || strstr(szLineBuffer, "End of the global") ) )
	  {
	     strcat(config, "\n");
	  }
    } 	  
    fclose(fp);
    free(szLineBuffer);
    free(szUserBuffer);

    /* Add the new config with the changed profile */
    if ( (fp = fopen("/etc/proftpd.conf", "w+")) == NULL) 
    {
        return;
    }
    strcat(config, changed_buffer); 
    fputs(config, fp);
    fclose(fp);
    free(changed_buffer);
    free(config);
    list_users(userlist_treeview, NULL);
    list_entire(userlist_treeview, NULL);
    gtk_widget_destroy(user_profile_window);
    system("killall -1 proftpd");
}


void
on_restore_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Ask what file(date) to restore (later) */
    GtkWidget *userlist_treeview;
    GtkWidget *entire_textview;
    system("cp /etc/gproftpd/proftpd.conf /etc");
    userlist_treeview = lookup_widget (GTK_WIDGET (button), "userlist_treeview");
    entire_textview = lookup_widget (GTK_WIDGET (button), "entire_textview");
    list_users(userlist_treeview, NULL);
    list_global(userlist_treeview, NULL);
    list_entire(entire_textview, NULL);
    /* Not restating the server popup */
}


void
on_backup_button_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Set date/time */
    system("cp /etc/proftpd.conf /etc/gproftpd"); 
}


void
on_syntaxcheck_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
    FILE *fp;
    GtkWidget *info_window;
    char *check_buffer;
    if ( (fp = popen("proftpd -t -c /etc/proftpd.conf 2>&1", "r")) == NULL)
    {
       strcpy(info_buffer, "Cant open /etc/proftpd.conf\n");
       info_window = create_info_window ();
       gtk_widget_show (info_window);       
       return;
    }
    fflush(fp);
    check_buffer=(char *)malloc(8192);
    bzero(check_buffer, sizeof(char) * 8192);   
    while (fgets(check_buffer, 8192, fp)!=NULL)
    {
    }
    strcpy(info_buffer, "If there are no complaints the configuration is ok.\n");
    strcat(info_buffer, check_buffer);
    pclose(fp);
    free(check_buffer);
    info_window = create_info_window();
    gtk_widget_show (info_window);
}


void
on_save_entire_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Save entire */
    FILE *fp;
    GtkWidget *entire_textview;
    GtkWidget *userlist_treeview;
    GtkTextBuffer *entire_config_text_buffer;
    GtkTextIter start, end;
    gchar *config_buffer=NULL;
    entire_textview = lookup_widget (GTK_WIDGET (button), "entire_textview");
    entire_config_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(entire_textview));
    gtk_text_buffer_get_bounds(entire_config_text_buffer, &start, &end);
    config_buffer = gtk_text_iter_get_text(&start, &end);
    /* Stick it in /etc/proftpd.conf */
    fp = fopen("/etc/proftpd.conf", "w+");
    fputs (config_buffer, fp);
    fclose (fp);
    /* Update the global tab, userlist, and the entire tab */
    userlist_treeview = lookup_widget (GTK_WIDGET (button), "userlist_treeview");
    entire_textview = lookup_widget (GTK_WIDGET (button), "entire_textview");
    list_users(userlist_treeview, NULL);
    list_entire(entire_textview, NULL);
    list_global(entire_textview, NULL);
    if(config_buffer !=NULL)
    g_free(config_buffer);
    system("killall -1 proftpd");
}


void
on_disc_update_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
   /* Update the disc tab */
   FILE *fp;
   GtkWidget *disc_treeview;
   GtkListStore *model;
   GtkTreeIter iter;
   GtkCellRenderer *cell;
   GtkTreeViewColumn *mount_column, *free_column, *used_column, *total_column, *percent_column, *device_column;
   gchar *utf8=NULL;
   char buf[8192]="";
   char mount[1024]="", free[1024]="", used[1024]="", total[1024]="", percent[1024]="", device[1024]="";
   disc_treeview = lookup_widget (GTK_WIDGET (button), "disc_treeview");
   model = gtk_list_store_new(6, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
   gtk_tree_view_set_model(GTK_TREE_VIEW(disc_treeview), GTK_TREE_MODEL (model));
   cell = gtk_cell_renderer_text_new();
   gtk_list_store_clear(model);
   mount_column = gtk_tree_view_column_new_with_attributes("Mounted on", cell, "text", 0, NULL);
   free_column = gtk_tree_view_column_new_with_attributes("Free space", cell, "text", 1, NULL);
   used_column = gtk_tree_view_column_new_with_attributes("Used space", cell, "text", 2, NULL);
   total_column = gtk_tree_view_column_new_with_attributes("Total space", cell, "text", 3, NULL);
   percent_column = gtk_tree_view_column_new_with_attributes("Percent used", cell, "text", 4, NULL);
   device_column = gtk_tree_view_column_new_with_attributes("Device", cell, "text", 5, NULL);

   if ( (fp = popen("df -h |grep /", "r")) == NULL) // was r
   {
     printf("\nError running df -h\n");
     return;
   }
   fflush(fp);

   while(fgets(buf, BUFSIZ, fp)!=NULL)
   {
      sscanf(buf, "%s %s %s %s %s %s", device, total, used, free, percent, mount);
      gtk_list_store_append(GTK_LIST_STORE(model), &iter);
      utf8 = g_locale_to_utf8(mount, strlen(mount), NULL, NULL, NULL);
      gtk_list_store_set(GTK_LIST_STORE(model), &iter, 0, utf8, -1);
      utf8 = g_locale_to_utf8(free, strlen(free), NULL, NULL, NULL);
      gtk_list_store_set(GTK_LIST_STORE(model), &iter, 1, utf8, -1);
      utf8 = g_locale_to_utf8(used, strlen(used), NULL, NULL, NULL);
      gtk_list_store_set(GTK_LIST_STORE(model), &iter, 2, utf8, -1);
      utf8 = g_locale_to_utf8(total, strlen(total), NULL, NULL, NULL);
      gtk_list_store_set(GTK_LIST_STORE(model), &iter, 3, utf8, -1);
      utf8 = g_locale_to_utf8(percent, strlen(percent), NULL, NULL, NULL);
      gtk_list_store_set(GTK_LIST_STORE(model), &iter, 4, utf8, -1);
      utf8 = g_locale_to_utf8(device, strlen(device), NULL, NULL, NULL);
      gtk_list_store_set(GTK_LIST_STORE(model), &iter, 5, utf8, -1);
   }
   pclose(fp);
   if(utf8 !=NULL)
   g_free(utf8);
}


	// FIXME
void
on_files_clear_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
    FILE *fp;
    GtkWidget *files_textview;
    GtkWidget *info_window;
    long size_buffer;
    char *file_buffer;
    char *get_file_buffer;
    gchar *utf8=NULL;
    GtkTextBuffer *file_text_buffer;
    system("rm -f /var/log/xferlog");
    system("touch /var/log/xferlog");
    files_textview = lookup_widget (GTK_WIDGET (button), "files_textview");
    if( (fp = fopen("/var/log/xferlog", "r")) == NULL)
    {
       strcpy(info_buffer, "Cant find /var/log/xferlog.\n\n");
       strcat(info_buffer, "If youre running GProFTPD as root\n");
       strcat(info_buffer, "the xferlog has been added for you.\n");
       info_window = create_info_window();
       gtk_widget_show(info_window);
       system("touch /var/log/xferlog");
       return;
    }
    fclose(fp);

    if( (fp = fopen("/var/log/xferlog", "r")) == NULL)
    {
       printf("Opening /var/log/xferlog failed\n");
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    file_buffer=(char *)malloc(size_buffer+8192);
    bzero(file_buffer, size_buffer+8192);
    get_file_buffer=(char *)malloc(size_buffer+8192);  
    bzero(get_file_buffer, size_buffer+8192);
    while (fgets(file_buffer, size_buffer+8192, fp)!=NULL)
    {
       strcat(get_file_buffer, file_buffer);
    }
    strcat(get_file_buffer, "\n");
    utf8 = g_locale_to_utf8(get_file_buffer, strlen(get_file_buffer), NULL, NULL, NULL);
    file_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(files_textview));
    gtk_text_buffer_set_text(file_text_buffer, utf8, strlen(utf8));
    fclose(fp);
    free(file_buffer);
    free(get_file_buffer);
    if(utf8 !=NULL)
    g_free(utf8);
}


void
on_files_update_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
    FILE *fp;
    GtkWidget *files_textview;
    GtkWidget *info_window;
    GtkTextBuffer *file_text_buffer;
    long size_buffer;
    char *file_buffer;
    char *get_file_buffer;
    gchar *utf8=NULL;
    files_textview = lookup_widget (GTK_WIDGET (button), "files_textview");
    if( (fp = fopen("/var/log/xferlog", "r")) == NULL)
    {
       strcpy(info_buffer, "Cant find /var/log/xferlog.\n\n");
       strcat(info_buffer, "If youre running GProFTPD as root\n");
       strcat(info_buffer, "the xferlog has been added for you.\n");
       info_window = create_info_window ();
       gtk_widget_show (info_window);
       system("touch /var/log/xferlog");
       return;
    }
    fclose(fp);

    if( (fp = fopen("/var/log/xferlog", "r")) == NULL)
    {
       printf("\nopen /var/log/xferlog failed\n");
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    file_buffer=(char *)malloc(size_buffer+8192);
    bzero(file_buffer, size_buffer+8192);
    get_file_buffer=(char *)malloc(size_buffer+8192);  
    bzero(get_file_buffer, size_buffer+8192);

    while (fgets(file_buffer, size_buffer+8192, fp)!=NULL)
    {
       strcat(get_file_buffer, file_buffer);
    }
    strcat(get_file_buffer, "\n");
    utf8 = g_locale_to_utf8(get_file_buffer, strlen(get_file_buffer), NULL, NULL, NULL);
    file_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(files_textview));
    gtk_text_buffer_set_text(file_text_buffer, utf8, strlen(utf8));
    fclose(fp);
    free(file_buffer);
    free(get_file_buffer);
    if(utf8 !=NULL)
    g_free(utf8);
}

	// FIXME
void
on_security_update_button_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
    FILE *fp;
    GtkWidget *info_window;
    GtkWidget *security_successful_textview;
    GtkWidget *security_refused_textview;
    long sizebuffer;
    char *s_buf;
    char *get_s_buf;
    gchar *utf8=NULL;
    GtkTextBuffer *security_text_buffer;
    if( (fp = fopen("/var/log/secure", "r")) == NULL) 
    {
       strcpy(info_buffer, "Couldnt find /var/log/secure\n\n");
       strcat(info_buffer, "so i added it.\n");
       system("touch /var/log/secure");
       info_window = create_info_window();
       gtk_widget_show(info_window);
       return;
    }
    security_successful_textview = lookup_widget (GTK_WIDGET (button), "security_successful_textview");
    security_refused_textview = lookup_widget (GTK_WIDGET (button), "security_refused_textview");
    fseek(fp, 0, SEEK_END);
    sizebuffer = ftell(fp);
    rewind(fp);
    s_buf=(char *)malloc(sizebuffer);
    bzero(s_buf, sizebuffer);   
    get_s_buf=(char *)malloc(sizebuffer+1024); // nope
    bzero(get_s_buf, sizebuffer+1024);   
    while(fgets(s_buf, sizebuffer, fp)!=NULL)
    {
      if( strstr(s_buf, "Login successful") )
      {
         strcat(get_s_buf, s_buf);
      }
    }
    security_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(security_successful_textview));
    utf8 = g_locale_to_utf8(get_s_buf, strlen(get_s_buf), NULL, NULL, NULL);
    gtk_text_buffer_set_text(security_text_buffer, utf8, strlen(utf8));
    fclose(fp);

    if( (fp = fopen("/var/log/secure", "r")) == NULL) 
    {
       strcpy(info_buffer, "Couldnt find /var/log/secure\n\n");
       strcat(info_buffer, "so i added it.\n");
       system("touch /var/log/secure");
       info_window = create_info_window();
       gtk_widget_show(info_window);
       return;
    }
    bzero(s_buf, sizebuffer);   
    bzero(get_s_buf, sizebuffer+1024);   
    while (fgets(s_buf, sizebuffer, fp)!=NULL)
    {
      if( strstr(s_buf, "Login failed") )
      {
         strcat(get_s_buf, s_buf);
      }

      if( strstr(s_buf, "refused") )
      {
         strcat(get_s_buf, s_buf);
      }

      if( strstr(s_buf, "no such user") )
      {
         strcat(get_s_buf, s_buf);
      }

      if( strstr(s_buf, "Maximum login attempts") )
      {
         strcat(get_s_buf, s_buf);
      }

      if( strstr(s_buf, "SECURITY VIOLATION") )
      {
         strcat(get_s_buf, s_buf);
      }
    }
    security_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(security_refused_textview));
    utf8 = g_locale_to_utf8(get_s_buf, strlen(get_s_buf), NULL, NULL, NULL);
    gtk_text_buffer_set_text(security_text_buffer, utf8, strlen(utf8));
    fclose(fp);
    if(utf8 !=NULL)
    g_free(utf8);
    free(s_buf);
    free(get_s_buf);
}


void
on_banned_save_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Save the banned users */
    FILE *fp;
    GtkWidget *info_window;
    GtkWidget *banned_textview;
    GtkTextBuffer *access_text_buffer;
    GtkTextIter start, end;
    gchar *profile;
    banned_textview = lookup_widget (GTK_WIDGET (button), "banned_textview");
    access_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(banned_textview));
    gtk_text_buffer_get_bounds(access_text_buffer, &start, &end);
    profile = gtk_text_iter_get_text(&start, &end);
    if ( (fp = fopen("/etc/ftpusers", "w+")) == NULL)
    {
       strcpy(info_buffer, "Couldnt open /etc/ftpusers for writing\n");
       strcat(info_buffer, "This is not good, Run GProFTPD as root\n");
       info_window = create_info_window();
       gtk_widget_show(info_window);
       printf("\nError saving /etc/ftpusers\n");
       return;
    }
    fputs (profile, fp);
    fclose (fp);
    if(profile !=NULL)
    g_free(profile);
}


void
on_kickban_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Kickban a user */
    FILE *fp;
    GtkWidget *info_window;
    GtkWidget *kickban_entry;
    GtkWidget *banned_textview;
    char *get_kick_ban_pid;
    char *kick_ban_pid;
    char *kick_ban;
    char *access_buffer;
    char *get_access_buffer;
    long size_buffer;
    G_CONST_RETURN gchar *kick_ban_username;
    GtkTextBuffer *user_control_text_buffer;
    gchar *utf8_access=NULL;
    banned_textview = lookup_widget (GTK_WIDGET (button), "banned_textview");
    kickban_entry = lookup_widget (GTK_WIDGET (button), "kickban_entry");
    kick_ban_username = gtk_entry_get_text(GTK_ENTRY(kickban_entry));
    if( strlen(kick_ban_username)==0 )
    {
	strcpy(info_buffer, "You must specify a username.");
	info_window = create_info_window();
        gtk_widget_show(info_window);
	return;
    }
    /* Put the banned user in /etc/ftpusers */
    fp = fopen("/etc/ftpusers", "a");
    fputs("\n", fp);
    fputs(kick_ban_username, fp);
    fclose(fp);
    /* Get the pid to kill */
    kick_ban_pid=(char *)malloc(4096);
    bzero(kick_ban_pid, sizeof(char) * 4096);   
    get_kick_ban_pid=(char *)malloc(4096);
    bzero(get_kick_ban_pid, sizeof(char) * 4096);   
    strcpy(get_kick_ban_pid, "ps -aux |grep \"proftpd: "); 
    strcat(get_kick_ban_pid, kick_ban_username);
    strcat(get_kick_ban_pid, "\" |awk '{print $2}'");
    if ( (fp = popen(get_kick_ban_pid, "r")) == NULL)
    {
       printf("\nCant get access to ps .. user not kicked\n");
       info_window = create_info_window();
       gtk_widget_show(info_window);
       return;
    }
    fflush(fp);
    while (fgets(kick_ban_pid, 4096, fp)!=NULL)
    {
    }
    pclose(fp);
    /* Kill the the users pid */
    kick_ban=(char *)malloc(4096);
    bzero(kick_ban, sizeof(char) * 4096);   
    strcpy(kick_ban, "kill "); 
    strcat(kick_ban, kick_ban_pid);
    system(kick_ban);
    free(get_kick_ban_pid);
    free(kick_ban_pid);
    free(kick_ban);
    /* Update user control tab from /etc/ftpusers */
    if( (fp = fopen("/etc/ftpusers", "r")) == NULL )
    {
       strcpy(info_buffer, "Couldnt find /etc/ftpusers\n");
       strcat(info_buffer, "This is not good, run GProFTPD as root.\n");
       info_window = create_info_window();
       gtk_widget_show(info_window);
       return;
    }
    fseek(fp, 0, SEEK_END);
    size_buffer = ftell(fp);
    rewind(fp);
    access_buffer=(char *)malloc(size_buffer);
    get_access_buffer=(char *)malloc(size_buffer+10);
    bzero(access_buffer, sizeof(char) * size_buffer);   
    bzero(get_access_buffer, sizeof(char) * size_buffer+10);   
    while (fgets(access_buffer, size_buffer, fp)!=NULL)
    {
       strcat(get_access_buffer, access_buffer);
    }
    /* Add an empty line so it can be conveniently filled in. */
    strcat(get_access_buffer, "\n");
    user_control_text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(banned_textview));
    utf8_access = g_locale_to_utf8(get_access_buffer, strlen(get_access_buffer), NULL, NULL, NULL);
    gtk_text_buffer_set_text(user_control_text_buffer, utf8_access, strlen(utf8_access));
    fclose(fp);
    free(access_buffer);
    free(get_access_buffer);
    if(utf8_access !=NULL)
    g_free(utf8_access);
}


void
on_kick_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Kick a user */
    FILE *fp;
    GtkWidget *info_window;
    GtkWidget *kick_entry;
    char *get_kick_pid;
    char *kick_pid;
    char *kick;
    G_CONST_RETURN gchar *kick_username;
    kick_entry = lookup_widget (GTK_WIDGET (button), "kick_entry");
    kick_username = gtk_entry_get_text(GTK_ENTRY(kick_entry));
    if( strlen(kick_username)==0 )
    {
	strcpy(info_buffer, "You must specify a username.");
	info_window = create_info_window();
        gtk_widget_show(info_window);
	return;
    }
    /* getting the pid to kill */
    get_kick_pid=(char *)malloc(1024);
    bzero(get_kick_pid, sizeof(char) * 1024);   
    strcpy(get_kick_pid, "ps -aux |grep \"proftpd: "); 
    strcat(get_kick_pid, kick_username);
    strcat(get_kick_pid, "\" |awk '{print $2}'");
    if ( (fp = popen(get_kick_pid, "r")) == NULL)
    {
       printf("\nCant get access to ps .. user not kicked\n");
       info_window = create_info_window();
       gtk_widget_show(info_window);
       return;
    }
    fflush(fp);
    kick_pid=(char *)malloc(1024);
    bzero(kick_pid, sizeof(char) * 1024);   
    while (fgets(kick_pid, 1024, fp)!=NULL)
    {
    }
    fclose(fp);
    free(get_kick_pid);
    free(kick_pid);
    /* Kill the user pid */
    kick=(char *)malloc(1024);
    bzero(kick, sizeof(char) * 1024);   
    strcpy(kick, "kill "); 
    strcat(kick, kick_pid);
    system(kick);
    free(kick);
}


void
on_shutdown_ok_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
    /* Shutdown the server */
    FILE *shutdown_file;
    char *shutdown;
    GtkWidget *shutdown_window;
    GtkWidget *new_acc_disabled_entry;
    GtkWidget *exist_users_dc_entry;
    GtkWidget *real_shutdown_entry;
    GtkWidget *shutdown_msg1_entry;
    G_CONST_RETURN gchar *get_new_login_disable;
    G_CONST_RETURN gchar *get_exist_user_disconnect;
    G_CONST_RETURN gchar *get_real_shutdown_entry;
    G_CONST_RETURN gchar *get_msg1;
    shutdown_window = lookup_widget (GTK_WIDGET (button), "shutdown_window");
    new_acc_disabled_entry = lookup_widget (GTK_WIDGET (button), "new_acc_disabled_entry");
    exist_users_dc_entry = lookup_widget (GTK_WIDGET (button), "exist_users_dc_entry");
    real_shutdown_entry = lookup_widget (GTK_WIDGET (button), "real_shutdown_entry");
    shutdown_msg1_entry = lookup_widget (GTK_WIDGET (button), "shutdown_msg1_entry");
    get_new_login_disable = gtk_entry_get_text(GTK_ENTRY(new_acc_disabled_entry));
    get_exist_user_disconnect = gtk_entry_get_text(GTK_ENTRY(exist_users_dc_entry));
    get_real_shutdown_entry = gtk_entry_get_text(GTK_ENTRY(real_shutdown_entry));
    get_msg1 = gtk_entry_get_text(GTK_ENTRY(shutdown_msg1_entry));
    shutdown=(char *)malloc(8192);
    bzero(shutdown, 8192);
    strcpy(shutdown, "ftpshut -l ");
    strcat(shutdown, get_new_login_disable);
    strcat(shutdown, " -d ");
    strcat(shutdown, get_exist_user_disconnect);
    strcat(shutdown, " ");
    strcat(shutdown, get_real_shutdown_entry);
    strcat(shutdown, " \"");
    strcat(shutdown, get_msg1);
    strcat(shutdown, "\"");
    shutdown_file = popen(shutdown,"r");
    pclose(shutdown_file);    
    free(shutdown);
    gtk_widget_hide(shutdown_window);
}


void
on_userdir_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
    /* If the directory button in the usertab is pressed show a selection */
    GtkWidget *userdir_selection;
    userdir_selection = create_userdir_selection();
    gtk_widget_show(userdir_selection);
}


void
on_userdir_select_ok_button_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
    GtkWidget *userdir_selection;
    G_CONST_RETURN gchar *userdir_path;
    userdir_selection = lookup_widget (GTK_WIDGET (button), "userdir_selection");
    userdir_path = gtk_file_selection_get_filename(GTK_FILE_SELECTION(userdir_selection));
    gtk_entry_set_text (GTK_ENTRY (useradd_directory_entry), userdir_path);
    gtk_editable_delete_text(GTK_EDITABLE(useradd_directory_entry), strlen(userdir_path)-1, strlen(userdir_path));
    gtk_widget_destroy(userdir_selection);
}


void
on_useradd_incoming_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
    /* If the incoming directory button in the usertab is pressed show a selection */
    GtkWidget *useradd_incoming_selection;
    useradd_incoming_selection = create_useradd_incoming_selection();
    gtk_widget_show(useradd_incoming_selection);
}


void
on_incoming_directory_ok_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
    GtkWidget *useradd_incoming_selection;
    G_CONST_RETURN gchar *incoming_path;
    char old_buffy[8192]="";
    char new_buffy[8192]="";
    int x=0;
    useradd_incoming_selection = lookup_widget (GTK_WIDGET (button), "useradd_incoming_selection");
    incoming_path = gtk_file_selection_get_filename(GTK_FILE_SELECTION(useradd_incoming_selection));

    /* Strip the full path */
    strcpy(old_buffy, incoming_path);
    for(x=strlen(old_buffy)-2; old_buffy[x]; x--)
    {
	if( old_buffy[x]=='/' )
	{
	    snprintf(new_buffy, old_buffy[x], old_buffy+x);
	    break;	
	}
    }
    gtk_entry_set_text (GTK_ENTRY (useradd_incoming_directory_entry), new_buffy);
    gtk_editable_delete_text(GTK_EDITABLE(useradd_incoming_directory_entry), strlen(new_buffy)-1, strlen(new_buffy));
    gtk_widget_destroy(useradd_incoming_selection);
}
