/*
 * Copyright (C) 2002, 2003 Emmanuel Saracco <esaracco@noos.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef H_UC_APPLICATION
#define H_UC_APPLICATION

#include "general.h"
#include "url.h"
#include "cache.h"
#include "check.h"
#include <gconf/gconf-client.h>


void uc_application_proxy_frame_control_sensitive (void);
void uc_application_remove_paths (void);
void uc_application_view_source_dialog_show (void);
void uc_application_dialog_show (const gchar * message,
				 const GtkMessageType msg_type);
void uc_application_update_ui (void);
void uc_application_init (void);
void uc_application_quit (void);
void uc_application_draw_main_frames (void);
void uc_application_get_data (void);
void uc_application_new_dialog_show (void);
void uc_application_open_dialog_show (void);
void uc_application_properties_init (void);
void uc_application_about_dialog_show (void);
void uc_application_progress_dialog_show ();
void uc_application_settings_dialog_show (void);
gboolean uc_application_settings_get_data (void);
void uc_application_status_code_properties_free (void);
void uc_application_status_code_properties_init (void);
UCStatusCode *uc_application_get_status_code_properties (const gchar *
							 status_code);

#endif
