/*
 * Copyright (C) 2002, 2003 Emmanuel Saracco <esaracco@noos.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "cache.h"


/*
 * return the source code of the given link id
 */
gchar *
uc_cache_get_source (const guint id)
{
  FILE *fd;
  gint nbr_read = 0;
  gchar buf[BUFFER_LEN + 1];
  gchar path[BUFFER_URL_LEN + 1] = { 0 };
  gchar *buffer = NULL;
  gchar *src = NULL;

  if ((snprintf
       (path, BUFFER_URL_LEN, "%s/%s/%d", projectState.working_path, PACKAGE,
	id) < 0))
    return NULL;

  if ((fd = fopen (path, "r")))
    {
      guint i = 0;

      while ((nbr_read = fread (buf, 1, BUFFER_LEN, fd)) != 0)
	{
	  buffer = g_realloc (buffer, i + nbr_read);
	  g_memmove (&buffer[i], buf, nbr_read);
	  i += nbr_read;
	}

      if (i)
	{
	  buffer = g_realloc (buffer, i + 1);
	  buffer[i] = '\0';
	}
      fclose (fd);

      src = buffer;
    }
  else
    src = NULL;

  return src;
}


/*
 * put a source page in the cache
 */
void
uc_cache_append_source (const guint id, const gchar * src)
{
  FILE *fd;
  gchar path[BUFFER_URL_LEN + 1] = { 0 };

  if ((!src) || (snprintf
		 (path, BUFFER_URL_LEN, "%s/%s/%d", projectState.working_path,
		  PACKAGE, id) < 0))
    return;

  fd = fopen (path, "w+");
  fprintf (fd, "%s", src);
  fclose (fd);
}
