/* 
 * Copyright (C) 2002, 2003 Emmanuel Saracco <esaracco@noos.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#include "callbacks.h"


void
on_view_link_content_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_view_source_dialog_show ();
}

void
on_quit_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_quit ();
}


void
on_new_project_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_new_dialog_show ();
}


void
on_about_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_about_dialog_show ();
}


void
on_settings_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_settings_dialog_show ();
}


void
on_display_badlinks_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  GtkTreeIter iter;

  uc_check_display_items_active_all ();
  gtk_tree_store_clear (treestore);
  uc_check_display_list_with_only (uc_check_get_properties_list (), iter,
				   UC_CHECK_DISPLAY_BADLINKS);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_badlinks", FALSE);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_collapse_all", FALSE);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_expand_all", FALSE);
}


void
on_display_goodlinks_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  GtkTreeIter iter;

  uc_check_display_items_active_all ();
  gtk_tree_store_clear (treestore);
  uc_check_display_list_with_only (uc_check_get_properties_list (), iter,
				   UC_CHECK_DISPLAY_GOODLINKS);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_goodlinks", FALSE);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_collapse_all", FALSE);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_expand_all", FALSE);
}


void
on_display_timeouts_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  GtkTreeIter iter;

  uc_check_display_items_active_all ();
  gtk_tree_store_clear (treestore);
  uc_check_display_list_with_only (uc_check_get_properties_list (), iter,
				   UC_CHECK_DISPLAY_TIMEOUTS);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_timeouts", FALSE);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_collapse_all", FALSE);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_expand_all", FALSE);
}

void
on_display_all_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  GtkTreeIter iter[10];
  guint i_iter = 0;

  uc_check_display_items_active_all ();
  gtk_tree_store_clear (treestore);
  uc_check_display_list (uc_check_get_properties_list (), iter, i_iter);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_all", FALSE);
}


void
on_display_collapse_all_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_check_display_items_active_all ();
  gtk_tree_view_collapse_all (treeview);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_collapse_all", FALSE);
}


void
on_display_expand_all_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_check_display_items_active_all ();
  gtk_tree_view_expand_all (treeview);
  UC_WIDGET_SET_SENSITIVE (glade_main_window, "display_expand_all", FALSE);
}


void
on_btCancel_newProjectDialog_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (new_project_dialog);
}

void
on_btOk_newProjectDialog_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_get_data ();
}


void
on_btCancel_settingsDialog_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (settings_dialog);
}


void
on_btOk_settingsDialog_clicked (GtkButton * button, gpointer user_data)
{
  if (uc_application_settings_get_data ())
    gtk_widget_destroy (settings_dialog);
}


void
on_btNewProject_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_new_dialog_show ();
}


void
on_mainWindow_destroy (GtkObject * object, gpointer user_data)
{
  uc_application_quit ();
}


void
on_btApply_settingsDialog_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_settings_get_data ();
}

void
on_urlsList_cursorChanged (GtkTreeView * selection, gpointer user_data)
{
  uc_check_display_informations (selection, DEFAULT_PRINTING);
}

void
on_btCancel_progressDialog_clicked (GtkButton * button, gpointer user_data)
{
  uc_check_cancel ();
}

void
on_btIgnore_progressDialog_clicked (GtkButton * button, gpointer user_data)
{
  uc_check_ignore_item ();
}

void
on_progressDialog_close (GtkDialog * dialog, gpointer user_data)
{
  uc_check_cancel ();
}

gboolean
on_progressDialog_destroy_event (GtkWidget * widget,
				 GdkEvent * event, gpointer user_data)
{
  uc_check_cancel ();
  return FALSE;
}


gboolean
on_progressDialog_delete_event (GtkWidget * widget,
				GdkEvent * event, gpointer user_data)
{
  uc_check_cancel ();
  return FALSE;
}

void
on_btBasicDisplayFormat_clicked (GtkButton * button, gpointer user_data)
{
  uc_check_display_informations (GTK_TREE_VIEW (user_data), SIMPLE_PRINTING);
}

void
on_btDetailedDisplayFormat_clicked (GtkButton * button, gpointer user_data)
{
  uc_check_display_informations (GTK_TREE_VIEW (user_data),
				 DETAILED_PRINTING);
}

void
on_bt_Close_viewSource_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (view_source_dialog);
}

void
on_radio_proxy_gnome_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_proxy_frame_control_sensitive ();
}

void
on_radio_proxy_none_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_proxy_frame_control_sensitive ();
}

void
on_radio_proxy_manual_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_proxy_frame_control_sensitive ();
}
