/* 
 * Copyright (C) 2002, 2003 Emmanuel Saracco <esaracco@noos.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#ifndef H_UC_GURLCHECKER
#define H_UC_GURLCHECKER


#include "general.h"
#include "report.h"
#include "callbacks.h"
#include "cache.h"
#include "application.h"


/* definition of the treeview columns */
enum
{
  UID_COLUMN,
  LINK_ICON_COLUMN,
  LABEL_COLUMN,
  URL_COLUMN,
  BG_COLOR_COLUMN,
  N_COLUMNS
};


/* enum to identify links types */
typedef enum
{
  LINK_TYPE_NONE,
  LINK_TYPE_HREF,
  LINK_TYPE_IMAGE,
  LINK_TYPES_LEN
}
UCLinkType;

void uc_check_timeout_flag_set (const gboolean flag);
gboolean uc_check_timeout_flag_get ();
void uc_check_timeout_add ();
gint uc_check_treeview_get_selected_row_id (void);
void uc_check_free_link_properties_list (GList * list);
void uc_check_free_tmp_list (void);
void uc_check_alarm_add (const guint seconds, gpointer callback);
void uc_check_alarm_remove (void);
void uc_check_buttons_display (const GtkWidget * frame, gpointer array,
			       const guint items_size,
			       gpointer selected_array,
			       const guint selected_items_size);
void uc_check_buttons_save_setting (GtkWidget * widget, gchar * path);
gboolean uc_check_display_informations (GtkTreeView * treeview,
					const UCDisplayFormat display_format);
void uc_check_begin (void);
void uc_check_cancel (void);
void uc_check_ignore_item (void);
void uc_check_display_items_active_all (void);
void uc_check_display_list (GList * list, GtkTreeIter iter[], guint i_iter);
void uc_check_display_list_with_only (GList * list, GtkTreeIter iter,
				      const guint view_type);
GList *uc_check_get_properties_list (void);
void uc_check_reset (void);
void uc_check_alarm_callback (int signo);
void uc_check_currentitem_set_host (gchar * host);
void uc_check_link_view_source (void);

#endif
