/*
 * Copyright (C) 2002, 2003 Emmanuel Saracco <esaracco@noos.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef H_UC_URL
#define H_UC_URL


#include "general.h"
#include "utils.h"


gchar *uc_url_get_hostname (const gchar * current_host, const gchar * url);
gchar *uc_url_add_protocol (const gchar * proto, const gchar * host);
gboolean uc_url_is_valid (const gchar * url);
gchar *uc_url_get_protocol (const gchar * url);
void uc_url_parse (const gchar * current_host, const gchar * current_path,
		   const gchar * url, gchar ** host, gchar ** port,
		   gchar ** dir, gchar ** file, gchar ** args);
gchar *uc_url_get_ip (gchar * host);

#endif
