/*
 * Copyright (C) 2002, 2003 Emmanuel Saracco <esaracco@noos.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef H_UC_UTILS
#define H_UC_UTILS


#include "general.h"
#include "check.h"
#include <gconf/gconf-client.h>


gchar *uc_utils_clean_tag_link_value (const gchar * value);
gpointer uc_utils_search_string_next (gpointer buf, const gchar * str,
				      const gchar limit_char);
void uc_utils_block_signals (void);
void uc_utils_unblock_signals (void);
gboolean uc_utils_memcasecmp (const gchar * str1, const gchar * str2);
gboolean uc_utils_working_path_is_valid (const gchar * file);
gchar *uc_utils_strpbrk_or_eos (const gchar * str, const gchar * accept);
gchar *uc_utils_strdup_delim (const gchar * begin, const gchar * end);
gboolean
uc_utils_array_is_in (const gchar * item, gpointer array, const guint size);
guint uc_utils_socket_open (gchar * host, const guint port,
			    const gboolean force_args_use);

#endif
