/***************************************************************************
                          alarmdlgimpl.h  -  description
                             -------------------
    begin                : Sat Oct 13 2001
    copyright           : (C) 2001-2003 by Jan Hambrecht
    email                : jaham@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ALARMDLGIMPL_H
#define ALARMDLGIMPL_H

#include <alarmdlg.h>
#include "birthdayoptions.h"
#include "birthdayscanner.h"
#include "birthdayitem.h"

#include <qlistview.h>


/**
* Implementation of alarm dialog base class
* @author Jan Hambrecht
*/

class AlarmDlgImpl : public AlarmDlg  {
	Q_OBJECT
public: 
	AlarmDlgImpl( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~AlarmDlgImpl();
	/** initialize dialog */
	bool init( BirthdayOptions *options );
protected: // Protected methods
	/** No descriptions */
	void resizeEvent( QResizeEvent* );
	/** No descriptions */
	void showEvent( QShowEvent * );
	/** fill birthday events into birthday list */
	void fillBirthday();
	/** fill anniversary events into anniversary list */
	void fillAnniversary();
private: // Private methods
	/** calculate width of columns */
	void arrangeColumns();
	/** event scanner */
	BirthdayScanner m_scanner;
	/** options '*/
	BirthdayOptions *m_options;
public slots:
   /**
   * receives clicked event from listview
   * @param item the item the user clicked on
   */
   void slotClicked(QListViewItem* item);
};

#endif
