/***************************************************************************
                          birthdayeventdata.cpp  -  description
                             -------------------
    begin                : Tue Aug 6 2002
    copyright           : (C) 2002,2003 by Jan Hambrecht
    email                : jaham@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "birthdayeventdata.h"

BirthdayEventData::BirthdayEventData()
{
	m_date = QDate().currentDate();
	m_name = "";
	m_days = 0;
	m_years = 0;
	m_color = QColor( 0, 0, 0 );
	m_uid = "";
}

BirthdayEventData::~BirthdayEventData()
{
}

/** set event date */
void BirthdayEventData::setDate( const QDate &date )
{
	if( ! date.isValid() ) return;

	m_date = date;
}

/** get event date */
QDate BirthdayEventData::getDate()
{                       
	return m_date;
}

/** set event name */
void BirthdayEventData::setName( const QString &name )
{                        
	if( name.isEmpty() ) return;
	
	m_name = name;
}

/** get event name */
QString BirthdayEventData::getName()
{                          
	return m_name;
}

/** set event days to today */
void BirthdayEventData::setDays( int days )
{
	m_days = days;
}

/** get event days to today */
int BirthdayEventData::getDays()
{
	return m_days;
}

/** set event years to today */
void BirthdayEventData::setYears( int years )
{
	m_years = years;
}

/**gset event years to today */
int BirthdayEventData::getYears()
{
	return m_years;
}

/** set font color */
void BirthdayEventData::setColor( const QColor &color )
{
	m_color = color;
}

/**get font color */
QColor BirthdayEventData::getColor()
{
	return m_color;
}

/** set uid */
void BirthdayEventData::setUid( const QString &uid )
{
	if( uid.isEmpty() ) return;
	
	m_uid = uid;
}

/** get uid */
QString BirthdayEventData::getUid()
{
	return m_uid;
}
