/***************************************************************************
                          birthdayeventdata.h  -  description
                             -------------------
    begin                : Tue Aug 6 2002
    copyright           : (C) 2002,2003 by Jan Hambrecht
    email                : jaham@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BIRTHDAYEVENTDATA_H
#define BIRTHDAYEVENTDATA_H

#include <qstring.h>
#include <qdatetime.h>
#include <qcolor.h>

/**
* this class contains data to show in notification dialog
* @author Jan Hambrecht
*/

class BirthdayEventData {
public: 
	BirthdayEventData();
	~BirthdayEventData();
	/** set event date */
	void setDate( const QDate &date );
	/** get event date */
	QDate getDate();
	/** set event name */
	void setName( const QString &name );
	/** get event name */
	QString getName();
	/** set event days to today */
	void setDays( int days );
	/** get event days to today */
	int getDays();
	/** set event years to today */
	void setYears( int years );
	/**get event years to today */
	int getYears();
	/** set font color */
	void setColor( const QColor &color );
	/**get font color */
	QColor getColor();
	/** set uid */
	void setUid( const QString &uid );
	/** get uid */
	QString getUid();
private:
	/** date of this event */
	QDate m_date;
	/** name of addressee */
	QString m_name;
	/** difference in days */
	int m_days;
	/** difference in years */
	int m_years;
	/** font color */
	QColor m_color;
	/** corresponding addressee uid */
	QString m_uid;
};

#endif
