/***************************************************************************
                          birthdayoptions.h  -  description
                             -------------------
    begin                : Fri Feb 22 2002
    copyright           : (C) 2002,2003 by Jan Hambrecht
    email                :  jaham@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BIRTHDAYOPTIONS_H
#define BIRTHDAYOPTIONS_H

#include <qcolor.h>

/**
* this class encapsulates all kbirthday options
* @author Jan Hambrecht
*/

class BirthdayOptions {
public:
	BirthdayOptions();
	~BirthdayOptions();
	/** get notification time in days for coming events*/
	uint getDaysComing();
	/** set notification time in days for coming events*/
	void setDaysComing( uint days );
	/** get notification time in days for passed events*/
	uint getDaysPassed();
	/** set notification time in days for passed events*/
	void setDaysPassed( uint days );
	/** get flag for notifying events on startup */
	bool getShowOnStartup();
	/** set flag for notifying events on startup */
	void setShowOnStartup( bool value );
	/** get flag for notifying anniversaries */
	bool getShowAnniversary();
	/** set flag for notifying anniversaries */
	void setShowAnniversary( bool value );
	/** save configuration options */
	void save();
	/** load configuration options */
	void load();
	/** get highlighting time in days */
	uint getDaysHighlight();
	/** set highlighting time in days */
	void setDaysHighlight( uint hlDays );
	/** get highlighting color */
	QColor getHighlightColor();
	/** set highlighting color */
	void setHighlightColor( QColor hlColor );
private: // Public attributes
	/** notification time in days */
	uint m_daysComing;
	/** notification time in days */
	uint m_daysPassed;
	/** highlighting time in days */
	uint m_daysHighlight;
	/** show events on startup (true/false)  */
	bool m_showOnStartup;
	/** show anniversaries (true/false)  */
	bool m_showAnniversary;
	/** highlighting color */
	QColor m_colorHighlight;
};

#endif
