/***************************************************************************
                          confdlgimpl.cpp  -  description
                             -------------------
    begin                : Fri Oct 12 2001
    copyright           : (C) 2001-2003 by Jan Hambrecht
    email                : jaham@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "confdlgimpl.h"
#include <kcolorbtn.h>
#include <qspinbox.h>
#include <qcheckbox.h>
 
ConfDlgImpl::ConfDlgImpl( QWidget* parent, const char* name, bool modal, WFlags fl )
	:ConfDlg( parent, name, modal, fl )
{
}

ConfDlgImpl::~ConfDlgImpl()
{
}

/** initialize controls with birthday options */
void ConfDlgImpl::setOptions( BirthdayOptions *options )
{
	sbDaysComing->setValue( options->getDaysComing() );
	sbDaysPassed->setValue( options->getDaysPassed() );
	sbDaysHighlight->setValue( options->getDaysHighlight() );
	cbShowOnStartup->setChecked( options->getShowOnStartup() );
	cbShowAnniversary->setChecked( options->getShowAnniversary() );
	kcbHighlight->setColor( options->getHighlightColor() );
}

/** read new birthday options from controls */
void ConfDlgImpl::getOptions( BirthdayOptions *options )
{
	options->setDaysComing( sbDaysComing->value() );
	options->setDaysPassed( sbDaysPassed->value() );
	options->setDaysHighlight( sbDaysHighlight->value() );
	options->setShowOnStartup( cbShowOnStartup->isChecked() );
	options->setShowAnniversary( cbShowAnniversary->isChecked() );
	options->setHighlightColor( kcbHighlight->color() );
}
