/***************************************************************************
                          kbirthday.h  -  description
                             -------------------
    begin                : Thu Oct 11 17:27:47 CEST 2001
    copyright           : (C) 2001-2003 by Jan Hambrecht
    email                : jaham@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBIRTHDAY_H
#define KBIRTHDAY_H

#include <kapp.h>
#include <kpanelapplet.h>
#include <kpopupmenu.h>
#include <kiconloader.h>
#include <kaboutapplication.h>

#include <qstring.h>
#include <qpixmap.h>
#include <qtoolbutton.h>
#include <qtooltip.h>

#include "confdlgimpl.h"
#include "alarmdlgimpl.h"

#define ICON_SIZE 20
#define APPLET_SIZE 24

/* XPM */
static const char *birthday[]={
"20 20 6 1",
". c None",
"# c #000000",
"d c #0058c0",
"c c #58a8ff",
"a c #a8dcff",
"b c #ffc0c0",
"....................",
"......#############.",
".....#aaaaabaaaaaa#.",
"....#aaaaabaaaaaac#.",
"...#bbbbbbbbbbbbcc#.",
"..#aaaaabaaaaaabcc#.",
".#aaaaabaaaaaacbcc#.",
".#dddddbdddddccbcc#.",
".#dddddbdddddccbcb#.",
".#dddddbdddddccbbc#.",
".#dddddbdddddccbcc#.",
".#dddddbdddddcbbcc#.",
".#bbbbbbbbbbbbcbcc#.",
".#dddddbdddddccbcc#.",
".#dddddbdddddccbc#..",
".#dddddbdddddccb#...",
".#dddddbdddddcc#....",
".#dddddbdddddc#.....",
".#############......",
"...................."};

class KBirthday : public KPanelApplet
{
Q_OBJECT
public:
/**
* Construct a @ref KPanelApplet just like any other widget.
*
* @param configFile The configFile handed over in the factory function.
* @param Type The applet @ref type().
* @param actions Standard RMB menu actions supported by the applet (see @ref action() ).
* @param parent The pointer to the parent widget handed over in the factory function.
* @param name A Qt object name for your applet.
**/
KBirthday(const QString& configFile, Type t = Normal, int actions = 0, QWidget *parent = 0, const char *name = 0);
/** destructor */
~KBirthday();
/**
* Retrieve a suggested width for a given height.
*
* Every applet should reimplement this function.
*
* Depending on the panel orientation the height (horizontal panel) or the
* width (vertical panel) of the applets is fixed.
* The exact values of the fixed size component depend on the panel size.
*
* On a horizontal panel the applet height is fixed, the panel will
* call @ref widthForHeight(int height) with @p height
* equal to 'the fixed applet height'
* when laying out the applets.
*
* The applet can now choose the other size component (width)
* based on the given height.
*
* The width you return is granted.
**/
int widthForHeight( int height ) const;
/**
* @return A suggested height for a given width.
*
* Every applet should reimplement this function.
*
* Depending on the panel orientation the height (horizontal panel) or the
* width (vertical panel) of the applets is fixed.
* The exact values of the fixed size component depend on the panel size.
*
* On a vertical panel the applet width is fixed, the panel will
* call @ref heightForWidth(int width) with @p width
* equal to 'the fixed applet width'
* when laying out the applets.
*
* The applet can now choose the other size component (height)
* based on the given width.
*
* The height you return is granted.
**/
int heightForWidth( int width) const;
/**
* Is called when the user selects "About" from the applets RMB menu.
* Reimplement this function to launch a about dialog.
*
* Note that this is called only when your applet supports the About action.
* See @ref Action and @ref KPanelApplet().
**/
void about();
	/**
	launch kde addressbook
	*/
	void launchAddressBook();

protected:
	void resizeEvent( QResizeEvent* );
	/** called when applet is shown */
	void showEvent( QShowEvent *e );

private:
	/** main popup menu */
	KPopupMenu *m_popup;
	/** icon pixmap */
	QPixmap *m_icon;
	/** button displaying the icon */
	QToolButton *m_button;
	/** configuration options */
	BirthdayOptions *m_options;
	/** about data */
	KAboutData *m_about;
	/** alarm dialog */
	AlarmDlgImpl m_alarm;
	/* Identifiers for menu items */
	enum MENUITEMS { ITEM_CONFIG = 1, ITEM_ALARM, ITEM_ABOUT, ITEM_ADDRESSBOOK };
private slots: // Private slots
	/** event handler for popup menu click */
	void popupClick(int id);
	/** show popup menu */
	void showPopup();
private: // Private methods
	/** show configuration dialog */
	void showPreferences(void);
	/** event handler for mouse click on applet */
	void mousePressEvent(QMouseEvent *e);
	/** arrange button with icon to cover the whole applet */
	void arrangeIcon(void);
	/** show alarm dialog */
	bool showEventsDlg( bool showMessage = true );
};

#endif
