/*
 * Copyright (C) 2002-2003 Stefan Holst
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: controlpc.c,v 1.3 2003/03/21 10:06:07 skaboy Exp $
 *
 * oxine controlpc
 */

#include <fstab.h>
#include <stdio.h>
#include "oxine.h"
#include "otk.h"
#include "xmlparser.h"
#include "controlpc.h"
#include "utils.h"


typedef struct control_power_data_s control_power_data_t;

struct control_power_data_s {
  oxine_t *oxine;
  otk_button_cb_t cb;
};

void controlpc_power_suspend(void *data);
void controlpc_power_reboot(void *data);
void controlpc_power_halt(void *data);


int check_isok(xine_health_check_t ch1, int check) {
  xine_health_check_t *result;

  result = xine_health_check(&ch1, check);
  switch(result->status) {
    case XINE_HEALTH_CHECK_NO_SUCH_CHECK:
      return -1;
    case XINE_HEALTH_CHECK_OK:
      return 1;
      break;
    case XINE_HEALTH_CHECK_FAIL:
      return 0;
      break;
    }
  return -1;
}

void controlpc_safequit(void *data) {
  controlpc_cbi_t *control = (controlpc_cbi_t *) data;
  oxine_t *oxine = control->oxine;
  otk_button_cb_t cb = control->cb;

  ho_free(control);
  cb(oxine);
}

void controlpc_mount_cb(void *data) {
  /* controlpc_cbi_t *control = (controlpc_cbi_t *) data;
  oxine_t *oxine = control->oxine;
  unsigned int sizey, sizex;
  unsigned int numy = 5, numx = 3;
  otk_widget_t *b;*/
  struct fstab *fss;

  setfsent();
  while((fss = getfsent()) != NULL) {
    printf("%s %s %s\n", fss->fs_spec, fss->fs_file, fss->fs_vfstype);
  }

  /*  otk_clear(oxine->otk);
   
  sizey = 480/numy;
  sizex = 680/numx;
 
  oxine->main_window = otk_window_new (oxine->otk, NULL, 50, 50, 700, 500);

  b = otk_button_new (oxine->main_window, 10, 10+sizey*0, sizex*2, sizey, "Checking for CDROM", NULL, NULL);  

  if(check_isok(ch1, CHECK_CDROM)) otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*0, sizex*1, sizey, "OK", NULL, NULL);
  else otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*0, sizex*1, sizey, "FAILED", NULL, NULL);


  otk_button_new (oxine->main_window, 10, 10+sizey*1, sizex*2, sizey, "Checking for DVD", NULL, NULL);  

  if(check_isok(ch1, CHECK_DVDROM)) otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*1, sizex*1, sizey, "OK", NULL, NULL);
  else otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*1, sizex*1, sizey, "FAILED", NULL, NULL);


  otk_button_new (oxine->main_window, 10, 10+sizey*2, sizex*2, sizey, "Checking for DMA", NULL, NULL);  

  if(check_isok(ch1, CHECK_CDROM)) otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*2, sizex*1, sizey, "OK", NULL, NULL);
  else otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*2, sizex*1, sizey, "FAILED", NULL, NULL);
  */

  /* otk_button_new (oxine->main_window, 10+sizex, 10+sizey*0, sizex, sizey, "Stop", media_stop_cb, oxine);  */
 
  /* otk_button_new (oxine->main_window, 10, 10+sizey*1, sizex, sizey, "Volume", NULL, NULL); */
  /* otk_slider_new (oxine->main_window, 10+sizex, 10+sizey*1, sizex, sizey, odk_get_volume); */

  /*  otk_button_new (oxine->main_window, 10, 10+sizey*2, sizex, sizey, "Seek", NULL, NULL); */
  /* otk_slider_new (oxine->main_window, 10+sizex, 10+sizey*2, sizex, sizey, odk_get_seek); */
   
  /*  otk_button_new (oxine->main_window, 10, 10+sizey*3, sizex*2, sizey, "Stream Information", media_info_cb, oxine); */
 
  /*otk_button_new (oxine->main_window, 10, 10+sizey*4, sizex, sizey, "Close", controlpc_safequit, control);  

  oxine->need_draw = 0;
  otk_set_focus(b);

  otk_draw_all(oxine->otk);*/
}

void controlpc_health_check(void *data) {
  controlpc_cbi_t *control = (controlpc_cbi_t *) data;
  oxine_t *oxine = control->oxine;
  unsigned int sizey, sizex;
  unsigned int numy = 5, numx = 3;
  xine_health_check_t ch1;
  otk_widget_t *b;

  /* If input.vcd_device is empty, we will set it to the default "/dev/cdrom" */
  ch1.cdrom_dev = xine_config_register_string(oxine->xine,
						 "input.vcd_device",
						 "/dev/cdrom",
						 "device used for cdrom drive",
						 NULL, 0, NULL, NULL);
  
  /* If input.dvd_device is empty, we will set it to the default "/dev/dvd" */
  ch1.dvd_dev = xine_config_register_string(oxine->xine,
					       "input.dvd_device",
					       "/dev/dvd",
					       "device used for dvd drive",
					       NULL, 0, NULL, NULL);


  otk_clear(oxine->otk);
   
  sizey = 480/numy;
  sizex = 680/numx;
 
  oxine->main_window = otk_window_new (oxine->otk, NULL, 50, 50, 700, 500);

  b = otk_button_new (oxine->main_window, 10, 10+sizey*0, sizex*2, sizey, "Checking for CDROM", NULL, NULL);  

  if(check_isok(ch1, CHECK_CDROM)) otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*0, sizex*1, sizey, "OK", NULL, NULL);
  else otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*0, sizex*1, sizey, "FAILED", NULL, NULL);


  otk_button_new (oxine->main_window, 10, 10+sizey*1, sizex*2, sizey, "Checking for DVD", NULL, NULL);  

  if(check_isok(ch1, CHECK_DVDROM)) otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*1, sizex*1, sizey, "OK", NULL, NULL);
  else otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*1, sizex*1, sizey, "FAILED", NULL, NULL);


  otk_button_new (oxine->main_window, 10, 10+sizey*2, sizex*2, sizey, "Checking for DMA", NULL, NULL);  

  if(check_isok(ch1, CHECK_CDROM)) otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*2, sizex*1, sizey, "OK", NULL, NULL);
  else otk_button_new (oxine->main_window, 10+sizex*2, 10+sizey*2, sizex*1, sizey, "FAILED", NULL, NULL);
 
  otk_button_new (oxine->main_window, 10, 10+sizey*4, sizex, sizey, "Close", controlpc_safequit, control);  

  /* oxine->need_draw = 0; */
  otk_set_focus(b);

  otk_draw_all(oxine->otk);

}

void controlpc_power_cb(void *data) {
  controlpc_cbi_t *control = (controlpc_cbi_t *) data;
  oxine_t *oxine = control->oxine;
  otk_widget_t *b, *layout;
  control_power_data_t *cdata = ho_new(control_power_data_t);

  cdata->oxine = oxine;
  cdata->cb = controlpc_power_cb;

  otk_clear(oxine->otk);
   
  oxine->main_window = otk_window_new (oxine->otk, NULL, 50, 50, 700, 500);
  layout = otk_layout_new(oxine->main_window, 10, 10, 680, 480, 4, 1);

  b = otk_button_grid_new("Suspend", controlpc_power_suspend, cdata);
  otk_layout_add_widget(layout, b, 0, 0, 1, 1);

  b = otk_button_grid_new("Reboot", controlpc_power_reboot, cdata);  
  otk_layout_add_widget(layout, b, 0, 1, 1, 1);

  b = otk_button_grid_new("Halt", controlpc_power_halt, cdata);  
  otk_layout_add_widget(layout, b, 0, 2, 1, 1);

  b = otk_button_grid_new("Close", controlpc_safequit, control);  
  otk_layout_add_widget(layout, b, 0, 3, 1, 1);
  otk_set_focus(b);

  otk_draw_all(oxine->otk);
}

void controlpc_power_suspend(void *data) {
  /*  control_power_data_t *cdata = (control_power_data_t *) data; */

  if(system("apm -s")) {
    printf("I can't suspend..\n");
  }
}

void controlpc_power_reboot(void *data) {
  /*  control_power_data_t *cdata = (control_power_data_t *) data; */

  if(system("reboot")) {
    printf("I can't reboot..\n");
  }
}

void controlpc_power_halt(void *data) {
  /*  control_power_data_t *cdata = (control_power_data_t *) data; */

  if(system("halt")) {
    printf("I can't halt..\n");
  }
}
