/*
 * Copyright (C) 2002-2003 Stefan Holst
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: disc.h,v 1.4 2003/03/18 11:48:04 holstsn Exp $
 *
 * autoplay different disc types
 */

#ifndef HAVE_AUTOCD_H
#define HAVE_AUTOCD_H

/*
 * recognized cd types
 */

#define AUTOCD_UNKNOWN 0   /* unknown disc type */
#define AUTOCD_NODISC  1   /* drive doesn't recognized any disc */
#define AUTOCD_DATA1   2   /* cd with data tracks, but not mountable */
#define AUTOCD_DATA2   3   /* xa based cd */
#define AUTOCD_DVD     4   /* dvd audio / video */
#define AUTOCD_VCD     5   /* video cd */
#define AUTOCD_SVCD    6   /* super video cd */
#define AUTOCD_AUDIO   7   /* audio cd */
#define AUTOCD_XA1     8   /* xa based cd */
#define AUTOCD_XA2     9   /* xa based cd without error correction (audio/video data) */
#define AUTOCD_MIXED   10  /* drive reports, that this is a mixed cd */
#define AUTOCD_LOMB    11  /* http://lomb.abeille.com */
#define AUTOCD_PSX     12
#define AUTOCD_CDROM   13  /* a mountable cdrom */

#if 0
int autocd_disc_in(const char *device);

int autocd_mount(const char *mountpoint);
int autocd_setspeed(const char *device, int speed);
#endif
int autocd_umount(const char *mountpoint);

int autocd_disc_type(const char *device, const char *mountpoint);
void disc_cb (void *data);
void disc_eject(oxine_t *oxine);

#endif
