/*
 * Copyright (C) 2002 Stefan Holst
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: x11.h,v 1.3 2003/03/17 16:38:18 holstsn Exp $
 *
 * the whole x11 stuff
 */

#ifndef HAVE_X11_H
#define HAVE_X11_H

#include "odk_plugin.h"
#include <xine.h>

/*
 * x11 window driver entrypoint and plugin description
 */

odk_window_t *x11_construct(xine_t *xine, const char *driver);

window_plugin_desc_t x11_plugin_desc[] = {
  { "x11", "x video extention output",     "xv",   x11_construct },
  { "x11", "x shared memory output",       "xshm", x11_construct },
  { "x11", "x window sdl output",          "sdl",  x11_construct },
  { "x11", "autodetected x window output", "auto", x11_construct },
  { NULL, NULL, NULL, NULL }
};

#endif
