# um, so this used to do a bit more than it does now
#
# Copyright (c) 2002 Juri Pakaste
# You may use and distribute this software under the terms of the
# GNU General Public License, version 2 or later
#

cvs_id = "$Id: FeedList.py,v 1.7 2003/03/15 20:29:28 juri Exp $"

import straw

class FeedList(list, straw.SignalEmitter):
    def __init__(self, init_seq = []):
        straw.SignalEmitter.__init__(self)
        self.initialize_slots(straw.FeedsChangedSignal)

        for item in init_seq:
            if type(item) is not straw.Feed:
                raise ValueError, "%s is not of type Feed" % item
            self.append(item)
            
    def __setitem__(self, key, value):
        if type(value) is not straw.Feed:
            raise ValueError, "%s is not of type Feed" % value
        list.__setitem__(self, key, value)
        value.signal_connect(straw.FeedsChangedSignal, self.feeds_changed)
        self.emit_signal(straw.FeedsChangedSignal(self))

    def append(self, value):
        list.append(self, value)
        value.signal_connect(straw.FeedsChangedSignal, self.feeds_changed)
        self.emit_signal(straw.FeedsChangedSignal(self))

    def switch(self, key1, key2):
        tmp = self[key1]
        list.__setitem__(self, key1, self[key2])
        list.__setitem__(self, key2, tmp)
        self.emit_signal(straw.FeedsChangedSignal(self))

    def reorder(self, move, delta):
        k = self[:]
        move = list(move)
        move.sort()
        if delta > 0:
            move.reverse()
        if move[0] == 0 and delta < 0 or move[-1] == (len(self) - 1) and delta > 0:
            return
        for m in move:
            k[m + delta], k[m] = k[m], k[m + delta]
        for i in range(len(k)):
            list.__setitem__(self, i, k[i])
        self.emit_signal(straw.FeedsChangedSignal(self))

    def __delitem__(self, value):
        list.__delitem__(self, value)
        self.emit_signal(straw.FeedsChangedSignal(self))

    def feeds_changed(self, signal):
        self.emit_signal(straw.FeedsChangedSignal(self))

    def sort(self, indices = None):
        if not indices or len(indices) == 1:
            list.sort(self, lambda a, b: cmp(a.title.lower(), b.title.lower()))
        else:
            items = []
            for i in indices:
                items.append(self[i])
            items.sort(lambda a, b: cmp(a.title.lower(), b.title.lower()))
            for i in range(len(items)):
                list.__setitem__(self, indices[i], items[i])
        self.emit_signal(straw.FeedsChangedSignal(self))

    def __hash__(self):
        h = 0
        for item in self:
            h ^= hash(item)
        return h

    def get_feed_with_id(self, id):
        for f in self:
            if f.id == id:
                return f
        return None
