cvs_id = "$Id: SummaryParserCommon.py,v 1.5 2003/03/14 22:38:55 juri Exp $"

### XML Head parsing
# this isn't exactly bullet proof
def find_declaration(xml):
    decl_end = xml.find("?>")
    if decl_end == -1:
        raise ValueError, "XML declaration not found"
    decl_start = xml[:decl_end].find("<?")
    if decl_start == -1:
        raise ValueError, "XML declaration not found"
    if decl_start > 0:
        if not xml[:decl_start].isspace():
            raise ValueError, "XML declaration not found"
    return (decl_start, decl_end + 2)

def find_encoding(decl):
    enc_start = decl.find("encoding")
    if enc_start > -1:
        i = enc_start + 8
        attr_start = 0
        decl_len = len(decl)
        while 1:
            i = i + 1
            if i == decl_len:
                raise ValueError, "XML not well-formed"
            if attr_start:
                if decl[i] == '"':
                    return (attr_start, i)
            else:
                if decl[i] == '"':
                    attr_start = i + 1
    return None

def read_encoding(xml):
    decl_limits = find_declaration(xml)
    loc = find_encoding(xml[decl_limits[0]:decl_limits[1]])
    if loc is None:
        return None
    return xml[(decl_limits[0] + loc[0]):(decl_limits[0] + loc[1])]

#### HTML Parsing

from xml.sax.saxutils import XMLGenerator
from xml.sax.xmlreader import AttributesImpl
import HTMLParser
import re
try:
    from cStringIO import StringIO
except:
    from StringIO import StringIO

# let's try to be a bit forgiving about the HTML contained in description.
# like allow unquoted attributes containing commas
HTMLParser.attrfind = re.compile(
    r'\s*([a-zA-Z_][-.:a-zA-Z_0-9]*)(\s*=\s*'
    r'(\'[^\']*\'|"[^"]*"|[-a-zA-Z0-9.,/:;+*%?!&$\(\)_#=~]*))?')

from HTMLParser import HTMLParser

class SXMLGenerator(XMLGenerator):
    def direct_characters(self, chars):
        self._out.write(chars)

class ItemDescriptionHandler(HTMLParser):
    def __init__(self, feed):
        HTMLParser.__init__(self)
        self._images = []
        self._feed = feed
        self._outstream = StringIO()
        self._xg = SXMLGenerator(self._outstream, encoding="utf-8")
        return

    def handle_starttag(self, tag, attrs):
        def t2d(t):
            d = {}
            for i in t:
                d[i[0]] = i[1]
            return d
        if tag == 'img':
            attrs = filter(lambda pair: pair[0] == 'src', attrs)
            if len(attrs) > 0:
                url = attrs[0][1]
                curl = self._feed.complete_url(url)
                self._images.append(curl)
        if tag != 'font':
            self._xg.startElement(tag, AttributesImpl(t2d(attrs)))
        return

    def handle_endtag(self, tag):
        if tag != 'font':
            self._xg.endElement(tag)

    def handle_data(self, data):
        self._xg.characters(data)

    def handle_charref(self, ref):
        self._xg.direct_characters("&#%s;" % ref)

    def handle_entityref(self, ref):
        self._xg.direct_characters("&%s;" % ref)
        
    def get_images(self):
        return self._images

    def get_data(self):
        return self._outstream.getvalue()

